/* Generated by TOM (version 2.5): Do not edit this file *//*
 *
 * TOM - To One Matching Compiler
 * 
 * Copyright (c) 2000-2007, INRIA
 * Nancy, France.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 * 
 * Pierre-Etienne Moreau  e-mail: Pierre-Etienne.Moreau@loria.fr
 *
 **/

package tom.engine.backend;

import java.io.IOException;

import tom.engine.TomBase;
import tom.engine.exception.TomRuntimeException;

import tom.engine.adt.tomsignature.*;
import tom.engine.adt.tomconstraint.types.*;
import tom.engine.adt.tomdeclaration.types.*;
import tom.engine.adt.tomexpression.types.*;
import tom.engine.adt.tominstruction.types.*;
import tom.engine.adt.tomname.types.*;
import tom.engine.adt.tomoption.types.*;
import tom.engine.adt.tomsignature.types.*;
import tom.engine.adt.tomterm.types.*;
import tom.engine.adt.tomslot.types.*;
import tom.engine.adt.tomtype.types.*;

import tom.engine.tools.OutputCode;
import tom.engine.tools.SymbolTable;
import tom.platform.OptionManager;

import aterm.*;

public abstract class TomAbstractGenerator {

  protected OutputCode output;
  protected OptionManager optionManager;
  protected SymbolTable symbolTable;
  protected boolean prettyMode;

  public TomAbstractGenerator(OutputCode output, OptionManager optionManager,
                              SymbolTable symbolTable) {
    this.symbolTable = symbolTable;
    this.optionManager = optionManager;
    this.output = output;
    this.prettyMode = ((Boolean)optionManager.getOptionValue("pretty")).booleanValue();
  }

  protected SymbolTable getSymbolTable(String moduleName) {
    //TODO//
    //Using of the moduleName
    ////////
    return symbolTable;
  }

  protected TomSymbol getSymbolFromName(String tomName) {
    return TomBase.getSymbolFromName(tomName, symbolTable);
  }

  protected TomSymbol getSymbolFromType(TomType tomType) {
    return TomBase.getSymbolFromType(tomType, symbolTable);
  }

  protected TomType getTermType(TomTerm t) {
    return TomBase.getTermType(t, symbolTable);
  }

  protected TomType getUniversalType() {
    return symbolTable.getUniversalType();
  }
// ------------------------------------------------------------
  /* Generated by TOM (version 2.5): Do not edit this file *//* Generated by TOM (version 2.5): Do not edit this file *//* Generated by TOM (version 2.5): Do not edit this file */ private static boolean tom_equal_term_String(String t1, String t2) { return  (t1.equals(t2)) ;}private static boolean tom_is_sort_String(String t) { return  t instanceof String ;}  /* Generated by TOM (version 2.5): Do not edit this file */private static boolean tom_equal_term_int(int t1, int t2) { return  (t1==t2) ;}private static boolean tom_is_sort_int(int t) { return  true ;} private static boolean tom_equal_term_Instruction(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_Instruction(Object t) { return  t instanceof tom.engine.adt.tominstruction.types.Instruction ;}private static boolean tom_equal_term_InstructionList(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_InstructionList(Object t) { return  t instanceof tom.engine.adt.tominstruction.types.InstructionList ;}private static boolean tom_equal_term_TomType(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_TomType(Object t) { return  t instanceof tom.engine.adt.tomtype.types.TomType ;}private static boolean tom_equal_term_TomForwardType(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_TomForwardType(Object t) { return  t instanceof tom.engine.adt.tomtype.types.TomForwardType ;}private static boolean tom_equal_term_Position(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_Position(Object t) { return  t instanceof tom.engine.adt.tomsignature.types.Position ;}private static boolean tom_equal_term_TargetLanguage(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_TargetLanguage(Object t) { return  t instanceof tom.engine.adt.tomsignature.types.TargetLanguage ;}private static boolean tom_equal_term_DeclarationList(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_DeclarationList(Object t) { return  t instanceof tom.engine.adt.tomdeclaration.types.DeclarationList ;}private static boolean tom_equal_term_Declaration(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_Declaration(Object t) { return  t instanceof tom.engine.adt.tomdeclaration.types.Declaration ;}private static boolean tom_equal_term_TomNumberList(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_TomNumberList(Object t) { return  t instanceof tom.engine.adt.tomname.types.TomNumberList ;}private static boolean tom_equal_term_TomName(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_TomName(Object t) { return  t instanceof tom.engine.adt.tomname.types.TomName ;}private static boolean tom_equal_term_Expression(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_Expression(Object t) { return  t instanceof tom.engine.adt.tomexpression.types.Expression ;}private static boolean tom_equal_term_Pattern(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_Pattern(Object t) { return  t instanceof tom.engine.adt.tomterm.types.Pattern ;}private static boolean tom_equal_term_TomList(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_TomList(Object t) { return  t instanceof tom.engine.adt.tomterm.types.TomList ;}private static boolean tom_equal_term_TomTerm(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_TomTerm(Object t) { return  t instanceof tom.engine.adt.tomterm.types.TomTerm ;}private static boolean tom_equal_term_PatternList(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_PatternList(Object t) { return  t instanceof tom.engine.adt.tomterm.types.PatternList ;}private static boolean tom_equal_term_Option(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_Option(Object t) { return  t instanceof tom.engine.adt.tomoption.types.Option ;}private static boolean tom_equal_term_OptionList(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_OptionList(Object t) { return  t instanceof tom.engine.adt.tomoption.types.OptionList ;}private static boolean tom_equal_term_ConstraintList(Object t1, Object t2) { return  t1.equals(t2) ;}private static boolean tom_is_sort_ConstraintList(Object t) { return  t instanceof tom.engine.adt.tomconstraint.types.ConstraintList ;}private static boolean tom_is_fun_sym_TomTermToInstruction( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.TomTermToInstruction ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_TomTermToInstruction_Tom( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getTom() ;}private static boolean tom_is_fun_sym_TargetLanguageToInstruction( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.TargetLanguageToInstruction ;}private static  tom.engine.adt.tomsignature.types.TargetLanguage  tom_get_slot_TargetLanguageToInstruction_Tl( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getTl() ;}private static boolean tom_is_fun_sym_If( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.If ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_If_Condition( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getCondition() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_If_SuccesInst( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getSuccesInst() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_If_FailureInst( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getFailureInst() ;}private static boolean tom_is_fun_sym_DoWhile( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.DoWhile ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_DoWhile_DoInst( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getDoInst() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_DoWhile_Condition( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getCondition() ;}private static boolean tom_is_fun_sym_WhileDo( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.WhileDo ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_WhileDo_Condition( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getCondition() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_WhileDo_DoInst( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getDoInst() ;}private static boolean tom_is_fun_sym_Assign( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.Assign ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_Assign_Variable( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getVariable() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Assign_Source( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getSource() ;}private static boolean tom_is_fun_sym_Let( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.Let ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_Let_Variable( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getVariable() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Let_Source( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getSource() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_Let_AstInstruction( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getAstInstruction() ;}private static boolean tom_is_fun_sym_LetRef( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.LetRef ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_LetRef_Variable( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getVariable() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_LetRef_Source( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getSource() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_LetRef_AstInstruction( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getAstInstruction() ;}private static boolean tom_is_fun_sym_LetAssign( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.LetAssign ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_LetAssign_Variable( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getVariable() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_LetAssign_Source( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getSource() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_LetAssign_AstInstruction( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getAstInstruction() ;}private static boolean tom_is_fun_sym_Return( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.Return ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_Return_Kid1( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getKid1() ;}private static boolean tom_is_fun_sym_Nop( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.Nop ;}private static boolean tom_is_fun_sym_AbstractBlock( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.AbstractBlock ;}private static  tom.engine.adt.tominstruction.types.InstructionList  tom_get_slot_AbstractBlock_InstList( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getInstList() ;}private static boolean tom_is_fun_sym_UnamedBlock( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.UnamedBlock ;}private static  tom.engine.adt.tominstruction.types.InstructionList  tom_get_slot_UnamedBlock_InstList( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getInstList() ;}private static boolean tom_is_fun_sym_NamedBlock( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.NamedBlock ;}private static  String  tom_get_slot_NamedBlock_BlockName( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getBlockName() ;}private static  tom.engine.adt.tominstruction.types.InstructionList  tom_get_slot_NamedBlock_InstList( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getInstList() ;}private static boolean tom_is_fun_sym_CompiledMatch( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.CompiledMatch ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_CompiledMatch_AutomataInst( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getAutomataInst() ;}private static  tom.engine.adt.tomoption.types.OptionList  tom_get_slot_CompiledMatch_Option( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getOption() ;}private static boolean tom_is_fun_sym_CompiledPattern( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.CompiledPattern ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_CompiledPattern_PatternList( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getPatternList() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_CompiledPattern_AutomataInst( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getAutomataInst() ;}private static boolean tom_is_fun_sym_TypedAction( tom.engine.adt.tominstruction.types.Instruction  t) { return  t instanceof tom.engine.adt.tominstruction.types.instruction.TypedAction ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_TypedAction_AstInstruction( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getAstInstruction() ;}private static  tom.engine.adt.tomterm.types.Pattern  tom_get_slot_TypedAction_PositivePattern( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getPositivePattern() ;}private static  tom.engine.adt.tomterm.types.PatternList  tom_get_slot_TypedAction_NegativePatternList( tom.engine.adt.tominstruction.types.Instruction  t) { return  t.getNegativePatternList() ;}private static boolean tom_is_fun_sym_Type( tom.engine.adt.tomtype.types.TomType  t) { return  t instanceof tom.engine.adt.tomtype.types.tomtype.Type ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_Type_TomType( tom.engine.adt.tomtype.types.TomType  t) { return  t.getTomType() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_Type_TlType( tom.engine.adt.tomtype.types.TomType  t) { return  t.getTlType() ;}private static boolean tom_is_fun_sym_ASTTomType( tom.engine.adt.tomtype.types.TomType  t) { return  t instanceof tom.engine.adt.tomtype.types.tomtype.ASTTomType ;}private static  String  tom_get_slot_ASTTomType_String( tom.engine.adt.tomtype.types.TomType  t) { return  t.getString() ;}private static boolean tom_is_fun_sym_TLType( tom.engine.adt.tomtype.types.TomType  t) { return  t instanceof tom.engine.adt.tomtype.types.tomtype.TLType ;}private static  tom.engine.adt.tomsignature.types.TargetLanguage  tom_get_slot_TLType_Tl( tom.engine.adt.tomtype.types.TomType  t) { return  t.getTl() ;}private static boolean tom_is_fun_sym_TextPosition( tom.engine.adt.tomsignature.types.Position  t) { return  t instanceof tom.engine.adt.tomsignature.types.position.TextPosition ;}private static  int  tom_get_slot_TextPosition_Line( tom.engine.adt.tomsignature.types.Position  t) { return  t.getLine() ;}private static  int  tom_get_slot_TextPosition_Column( tom.engine.adt.tomsignature.types.Position  t) { return  t.getColumn() ;}private static boolean tom_is_fun_sym_TL( tom.engine.adt.tomsignature.types.TargetLanguage  t) { return  t instanceof tom.engine.adt.tomsignature.types.targetlanguage.TL ;}private static  String  tom_get_slot_TL_Code( tom.engine.adt.tomsignature.types.TargetLanguage  t) { return  t.getCode() ;}private static  tom.engine.adt.tomsignature.types.Position  tom_get_slot_TL_Start( tom.engine.adt.tomsignature.types.TargetLanguage  t) { return  t.getStart() ;}private static  tom.engine.adt.tomsignature.types.Position  tom_get_slot_TL_End( tom.engine.adt.tomsignature.types.TargetLanguage  t) { return  t.getEnd() ;}private static boolean tom_is_fun_sym_ITL( tom.engine.adt.tomsignature.types.TargetLanguage  t) { return  t instanceof tom.engine.adt.tomsignature.types.targetlanguage.ITL ;}private static  String  tom_get_slot_ITL_Code( tom.engine.adt.tomsignature.types.TargetLanguage  t) { return  t.getCode() ;}private static boolean tom_is_fun_sym_Comment( tom.engine.adt.tomsignature.types.TargetLanguage  t) { return  t instanceof tom.engine.adt.tomsignature.types.targetlanguage.Comment ;}private static  String  tom_get_slot_Comment_Code( tom.engine.adt.tomsignature.types.TargetLanguage  t) { return  t.getCode() ;}private static boolean tom_is_fun_sym_TypeTermDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.TypeTermDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_TypeTermDecl_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomdeclaration.types.DeclarationList  tom_get_slot_TypeTermDecl_Declarations( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getDeclarations() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_TypeTermDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_GetImplementationDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.GetImplementationDecl ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetImplementationDecl_Variable( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVariable() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_GetImplementationDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_GetImplementationDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_IsFsymDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.IsFsymDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_IsFsymDecl_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_IsFsymDecl_Variable( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVariable() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_IsFsymDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_IsFsymDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_GetSlotDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.GetSlotDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetSlotDecl_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetSlotDecl_SlotName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getSlotName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSlotDecl_Variable( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVariable() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_GetSlotDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_GetSlotDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_EqualTermDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.EqualTermDecl ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_EqualTermDecl_TermArg1( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getTermArg1() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_EqualTermDecl_TermArg2( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getTermArg2() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_EqualTermDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_EqualTermDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_IsSortDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.IsSortDecl ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_IsSortDecl_TermArg( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getTermArg() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_IsSortDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_IsSortDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_GetHeadDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.GetHeadDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetHeadDecl_Opname( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_GetHeadDecl_Codomain( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getCodomain() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetHeadDecl_Variable( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVariable() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_GetHeadDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_GetHeadDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_GetTailDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.GetTailDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetTailDecl_Opname( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetTailDecl_Variable( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVariable() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_GetTailDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_GetTailDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_IsEmptyDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.IsEmptyDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_IsEmptyDecl_Opname( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_IsEmptyDecl_Variable( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVariable() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_IsEmptyDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_IsEmptyDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_MakeEmptyList( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.MakeEmptyList ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_MakeEmptyList_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_MakeEmptyList_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_MakeEmptyList_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_MakeAddList( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.MakeAddList ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_MakeAddList_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_MakeAddList_VarElt( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVarElt() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_MakeAddList_VarList( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVarList() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_MakeAddList_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_MakeAddList_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_GetElementDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.GetElementDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetElementDecl_Opname( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetElementDecl_Variable( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVariable() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetElementDecl_Index( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getIndex() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_GetElementDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_GetElementDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_GetSizeDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.GetSizeDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetSizeDecl_Opname( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSizeDecl_Variable( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVariable() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_GetSizeDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_GetSizeDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_MakeEmptyArray( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.MakeEmptyArray ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_MakeEmptyArray_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_MakeEmptyArray_VarSize( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVarSize() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_MakeEmptyArray_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_MakeEmptyArray_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_MakeAddArray( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.MakeAddArray ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_MakeAddArray_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_MakeAddArray_VarElt( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVarElt() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_MakeAddArray_VarList( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getVarList() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_MakeAddArray_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_MakeAddArray_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_MakeDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.MakeDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_MakeDecl_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_MakeDecl_AstType( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstType() ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_MakeDecl_Args( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getArgs() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_MakeDecl_Instr( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstr() ;}private static  tom.engine.adt.tomoption.types.Option  tom_get_slot_MakeDecl_OrgTrack( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getOrgTrack() ;}private static boolean tom_is_fun_sym_FunctionDef( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.FunctionDef ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_FunctionDef_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_FunctionDef_ArgumentList( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getArgumentList() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_FunctionDef_Codomain( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getCodomain() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_FunctionDef_ThrowsType( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getThrowsType() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_FunctionDef_Instruction( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstruction() ;}private static boolean tom_is_fun_sym_MethodDef( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.MethodDef ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_MethodDef_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_MethodDef_ArgumentList( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getArgumentList() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_MethodDef_Codomain( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getCodomain() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_MethodDef_ThrowsType( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getThrowsType() ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_MethodDef_Instruction( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getInstruction() ;}private static boolean tom_is_fun_sym_Class( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.Class ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_Class_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomtype.types.TomForwardType  tom_get_slot_Class_ExtendsType( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getExtendsType() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_Class_SuperTerm( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getSuperTerm() ;}private static  tom.engine.adt.tomdeclaration.types.Declaration  tom_get_slot_Class_Declaration( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getDeclaration() ;}private static boolean tom_is_fun_sym_SymbolDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.SymbolDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_SymbolDecl_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static boolean tom_is_fun_sym_ListSymbolDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.ListSymbolDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_ListSymbolDecl_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static boolean tom_is_fun_sym_ArraySymbolDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.ArraySymbolDecl ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_ArraySymbolDecl_AstName( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getAstName() ;}private static boolean tom_is_fun_sym_EmptyDeclaration( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.EmptyDeclaration ;}private static boolean tom_is_fun_sym_AbstractDecl( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t instanceof tom.engine.adt.tomdeclaration.types.declaration.AbstractDecl ;}private static  tom.engine.adt.tomdeclaration.types.DeclarationList  tom_get_slot_AbstractDecl_DeclList( tom.engine.adt.tomdeclaration.types.Declaration  t) { return  t.getDeclList() ;}private static boolean tom_is_fun_sym_Name( tom.engine.adt.tomname.types.TomName  t) { return  t instanceof tom.engine.adt.tomname.types.tomname.Name ;}private static  String  tom_get_slot_Name_String( tom.engine.adt.tomname.types.TomName  t) { return  t.getString() ;}private static boolean tom_is_fun_sym_PositionName( tom.engine.adt.tomname.types.TomName  t) { return  t instanceof tom.engine.adt.tomname.types.tomname.PositionName ;}private static  tom.engine.adt.tomname.types.TomNumberList  tom_get_slot_PositionName_NumberList( tom.engine.adt.tomname.types.TomName  t) { return  t.getNumberList() ;}private static boolean tom_is_fun_sym_TomTermToExpression( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.TomTermToExpression ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_TomTermToExpression_AstTerm( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getAstTerm() ;}private static boolean tom_is_fun_sym_Bottom( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.Bottom ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_Bottom_TomType( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getTomType() ;}private static boolean tom_is_fun_sym_Negation( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.Negation ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_make_Negation( tom.engine.adt.tomexpression.types.Expression  t0) { return  tom.engine.adt.tomexpression.types.expression.Negation.make(t0) ; }private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Negation_Arg( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getArg() ;}private static boolean tom_is_fun_sym_And( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.And ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_And_Arg1( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getArg1() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_And_Arg2( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getArg2() ;}private static boolean tom_is_fun_sym_Or( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.Or ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Or_Arg1( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getArg1() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Or_Arg2( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getArg2() ;}private static boolean tom_is_fun_sym_GreaterThan( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.GreaterThan ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_GreaterThan_Arg1( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getArg1() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_GreaterThan_Arg2( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getArg2() ;}private static boolean tom_is_fun_sym_Conditional( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.Conditional ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Conditional_Cond( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getCond() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Conditional_Then( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getThen() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Conditional_Else( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getElse() ;}private static boolean tom_is_fun_sym_TrueTL( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.TrueTL ;}private static boolean tom_is_fun_sym_FalseTL( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.FalseTL ;}private static boolean tom_is_fun_sym_EqualTerm( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.EqualTerm ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_EqualTerm_TomType( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getTomType() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_EqualTerm_Kid1( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getKid1() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_EqualTerm_Kid2( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getKid2() ;}private static boolean tom_is_fun_sym_Cast( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.Cast ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_Cast_AstType( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getAstType() ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_Cast_Source( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getSource() ;}private static boolean tom_is_fun_sym_GetSlot( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.GetSlot ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_GetSlot_Codomain( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getCodomain() ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetSlot_AstName( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getAstName() ;}private static  String  tom_get_slot_GetSlot_SlotNameString( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getSlotNameString() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSlot_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static boolean tom_is_fun_sym_IsFsym( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.IsFsym ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_IsFsym_AstName( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_IsFsym_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static boolean tom_is_fun_sym_GetHead( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.GetHead ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetHead_Opname( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_GetHead_Codomain( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getCodomain() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetHead_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static boolean tom_is_fun_sym_GetTail( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.GetTail ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetTail_Opname( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetTail_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static boolean tom_is_fun_sym_IsEmptyList( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.IsEmptyList ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_IsEmptyList_Opname( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_IsEmptyList_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static boolean tom_is_fun_sym_IsEmptyArray( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.IsEmptyArray ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_IsEmptyArray_Opname( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_IsEmptyArray_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_IsEmptyArray_Index( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getIndex() ;}private static boolean tom_is_fun_sym_AddOne( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.AddOne ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_AddOne_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static boolean tom_is_fun_sym_GetSize( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.GetSize ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetSize_Opname( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSize_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static boolean tom_is_fun_sym_GetElement( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.GetElement ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetElement_Opname( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getOpname() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_GetElement_Codomain( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getCodomain() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetElement_Kid1( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getKid1() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetElement_Kid2( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getKid2() ;}private static boolean tom_is_fun_sym_GetSliceList( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.GetSliceList ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetSliceList_AstName( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSliceList_VariableBeginAST( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariableBeginAST() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSliceList_VariableEndAST( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariableEndAST() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSliceList_Tail( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getTail() ;}private static boolean tom_is_fun_sym_GetSliceArray( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.GetSliceArray ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_GetSliceArray_AstName( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSliceArray_SubjectListName( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getSubjectListName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSliceArray_VariableBeginAST( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariableBeginAST() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_GetSliceArray_VariableEndAST( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariableEndAST() ;}private static boolean tom_is_fun_sym_IsSort( tom.engine.adt.tomexpression.types.Expression  t) { return  t instanceof tom.engine.adt.tomexpression.types.expression.IsSort ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_IsSort_AstType( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getAstType() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_IsSort_Variable( tom.engine.adt.tomexpression.types.Expression  t) { return  t.getVariable() ;}private static boolean tom_is_fun_sym_Variable( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.Variable ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_make_Variable( tom.engine.adt.tomoption.types.OptionList  t0,  tom.engine.adt.tomname.types.TomName  t1,  tom.engine.adt.tomtype.types.TomType  t2,  tom.engine.adt.tomconstraint.types.ConstraintList  t3) { return  tom.engine.adt.tomterm.types.tomterm.Variable.make(t0, t1, t2, t3) ; }private static  tom.engine.adt.tomoption.types.OptionList  tom_get_slot_Variable_Option( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getOption() ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_Variable_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_Variable_AstType( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstType() ;}private static  tom.engine.adt.tomconstraint.types.ConstraintList  tom_get_slot_Variable_Constraints( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getConstraints() ;}private static boolean tom_is_fun_sym_VariableStar( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.VariableStar ;}private static  tom.engine.adt.tomoption.types.OptionList  tom_get_slot_VariableStar_Option( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getOption() ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_VariableStar_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_VariableStar_AstType( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstType() ;}private static  tom.engine.adt.tomconstraint.types.ConstraintList  tom_get_slot_VariableStar_Constraints( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getConstraints() ;}private static boolean tom_is_fun_sym_UnamedVariable( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.UnamedVariable ;}private static  tom.engine.adt.tomoption.types.OptionList  tom_get_slot_UnamedVariable_Option( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getOption() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_UnamedVariable_AstType( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstType() ;}private static  tom.engine.adt.tomconstraint.types.ConstraintList  tom_get_slot_UnamedVariable_Constraints( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getConstraints() ;}private static boolean tom_is_fun_sym_UnamedVariableStar( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.UnamedVariableStar ;}private static  tom.engine.adt.tomoption.types.OptionList  tom_get_slot_UnamedVariableStar_Option( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getOption() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_UnamedVariableStar_AstType( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstType() ;}private static  tom.engine.adt.tomconstraint.types.ConstraintList  tom_get_slot_UnamedVariableStar_Constraints( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getConstraints() ;}private static boolean tom_is_fun_sym_TargetLanguageToTomTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.TargetLanguageToTomTerm ;}private static  tom.engine.adt.tomsignature.types.TargetLanguage  tom_get_slot_TargetLanguageToTomTerm_Tl( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getTl() ;}private static boolean tom_is_fun_sym_DeclarationToTomTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.DeclarationToTomTerm ;}private static  tom.engine.adt.tomdeclaration.types.Declaration  tom_get_slot_DeclarationToTomTerm_AstDeclaration( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstDeclaration() ;}private static boolean tom_is_fun_sym_ExpressionToTomTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.ExpressionToTomTerm ;}private static  tom.engine.adt.tomexpression.types.Expression  tom_get_slot_ExpressionToTomTerm_AstExpression( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstExpression() ;}private static boolean tom_is_fun_sym_InstructionToTomTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.InstructionToTomTerm ;}private static  tom.engine.adt.tominstruction.types.Instruction  tom_get_slot_InstructionToTomTerm_AstInstruction( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstInstruction() ;}private static boolean tom_is_fun_sym_Tom( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.Tom ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_Tom_TomList( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getTomList() ;}private static boolean tom_is_fun_sym_TomInclude( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.TomInclude ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_TomInclude_TomList( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getTomList() ;}private static boolean tom_is_fun_sym_Composite( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.Composite ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_Composite_Args( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getArgs() ;}private static boolean tom_is_fun_sym_Ref( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.Ref ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_Ref_TomTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getTomTerm() ;}private static boolean tom_is_fun_sym_FunctionCall( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.FunctionCall ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_FunctionCall_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomtype.types.TomType  tom_get_slot_FunctionCall_AstType( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstType() ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_FunctionCall_Args( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getArgs() ;}private static boolean tom_is_fun_sym_BuildConstant( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.BuildConstant ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_BuildConstant_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static boolean tom_is_fun_sym_BuildTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.BuildTerm ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_BuildTerm_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_slot_BuildTerm_Args( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getArgs() ;}private static  String  tom_get_slot_BuildTerm_ModuleName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getModuleName() ;}private static boolean tom_is_fun_sym_BuildEmptyList( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.BuildEmptyList ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_BuildEmptyList_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static boolean tom_is_fun_sym_BuildConsList( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.BuildConsList ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_BuildConsList_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_BuildConsList_HeadTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getHeadTerm() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_BuildConsList_TailTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getTailTerm() ;}private static boolean tom_is_fun_sym_BuildAppendList( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.BuildAppendList ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_BuildAppendList_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_BuildAppendList_HeadTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getHeadTerm() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_BuildAppendList_TailTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getTailTerm() ;}private static boolean tom_is_fun_sym_BuildEmptyArray( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.BuildEmptyArray ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_BuildEmptyArray_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  int  tom_get_slot_BuildEmptyArray_Size( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getSize() ;}private static boolean tom_is_fun_sym_BuildConsArray( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.BuildConsArray ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_BuildConsArray_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_BuildConsArray_HeadTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getHeadTerm() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_BuildConsArray_TailTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getTailTerm() ;}private static boolean tom_is_fun_sym_BuildAppendArray( tom.engine.adt.tomterm.types.TomTerm  t) { return  t instanceof tom.engine.adt.tomterm.types.tomterm.BuildAppendArray ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_BuildAppendArray_AstName( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getAstName() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_BuildAppendArray_HeadTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getHeadTerm() ;}private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_slot_BuildAppendArray_TailTerm( tom.engine.adt.tomterm.types.TomTerm  t) { return  t.getTailTerm() ;}private static boolean tom_is_fun_sym_DeclarationToOption( tom.engine.adt.tomoption.types.Option  t) { return  t instanceof tom.engine.adt.tomoption.types.option.DeclarationToOption ;}private static  tom.engine.adt.tomdeclaration.types.Declaration  tom_get_slot_DeclarationToOption_AstDeclaration( tom.engine.adt.tomoption.types.Option  t) { return  t.getAstDeclaration() ;}private static boolean tom_is_fun_sym_DefinedSymbol( tom.engine.adt.tomoption.types.Option  t) { return  t instanceof tom.engine.adt.tomoption.types.option.DefinedSymbol ;}private static boolean tom_is_fun_sym_OriginTracking( tom.engine.adt.tomoption.types.Option  t) { return  t instanceof tom.engine.adt.tomoption.types.option.OriginTracking ;}private static  tom.engine.adt.tomname.types.TomName  tom_get_slot_OriginTracking_AstName( tom.engine.adt.tomoption.types.Option  t) { return  t.getAstName() ;}private static  int  tom_get_slot_OriginTracking_Line( tom.engine.adt.tomoption.types.Option  t) { return  t.getLine() ;}private static  String  tom_get_slot_OriginTracking_FileName( tom.engine.adt.tomoption.types.Option  t) { return  t.getFileName() ;}private static boolean tom_is_fun_sym_concTomTerm( tom.engine.adt.tomterm.types.TomList  t) { return  t instanceof tom.engine.adt.tomterm.types.tomlist.ConsconcTomTerm || t instanceof tom.engine.adt.tomterm.types.tomlist.EmptyconcTomTerm ;}private static  tom.engine.adt.tomterm.types.TomList  tom_empty_list_concTomTerm() { return  tom.engine.adt.tomterm.types.tomlist.EmptyconcTomTerm.make() ; }private static  tom.engine.adt.tomterm.types.TomList  tom_cons_list_concTomTerm( tom.engine.adt.tomterm.types.TomTerm  e,  tom.engine.adt.tomterm.types.TomList  l) { return  tom.engine.adt.tomterm.types.tomlist.ConsconcTomTerm.make(e,l) ; }private static  tom.engine.adt.tomterm.types.TomTerm  tom_get_head_concTomTerm_TomList( tom.engine.adt.tomterm.types.TomList  l) { return  l.getHeadconcTomTerm() ;}private static  tom.engine.adt.tomterm.types.TomList  tom_get_tail_concTomTerm_TomList( tom.engine.adt.tomterm.types.TomList  l) { return  l.getTailconcTomTerm() ;}private static boolean tom_is_empty_concTomTerm_TomList( tom.engine.adt.tomterm.types.TomList  l) { return  l.isEmptyconcTomTerm() ;}   private static   tom.engine.adt.tomterm.types.TomList  tom_append_list_concTomTerm( tom.engine.adt.tomterm.types.TomList l1,  tom.engine.adt.tomterm.types.TomList  l2) {     if(tom_is_empty_concTomTerm_TomList(l1)) {       return l2;     } else if(tom_is_empty_concTomTerm_TomList(l2)) {       return l1;     } else if(tom_is_empty_concTomTerm_TomList(tom_get_tail_concTomTerm_TomList(l1))) {       return ( tom.engine.adt.tomterm.types.TomList )tom_cons_list_concTomTerm(tom_get_head_concTomTerm_TomList(l1),l2);     } else {       return ( tom.engine.adt.tomterm.types.TomList )tom_cons_list_concTomTerm(tom_get_head_concTomTerm_TomList(l1),tom_append_list_concTomTerm(tom_get_tail_concTomTerm_TomList(l1),l2));     }   }   private static   tom.engine.adt.tomterm.types.TomList  tom_get_slice_concTomTerm( tom.engine.adt.tomterm.types.TomList  begin,  tom.engine.adt.tomterm.types.TomList  end, tom.engine.adt.tomterm.types.TomList  tail) {     if(tom_equal_term_TomList(begin,end)) {       return tail;     } else {       return ( tom.engine.adt.tomterm.types.TomList )tom_cons_list_concTomTerm(tom_get_head_concTomTerm_TomList(begin),( tom.engine.adt.tomterm.types.TomList )tom_get_slice_concTomTerm(tom_get_tail_concTomTerm_TomList(begin),end,tail));     }   }    
// ------------------------------------------------------------

  protected TomTerm operatorsTogenerate(TomTerm subject)throws IOException {
    //System.out.println("Subject "+subject);
    //collectMake(subject);
    return subject;
  }

  /**
   * Generate the goal language
   * 
   * @param deep 
   * 		The distance from the right side (allows the computation of the column number)
   */
  protected void generate(int deep, TomTerm subject, String moduleName)throws IOException {
    if (tom_is_sort_TomTerm(subject)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch39NameNumberfreshSubject_1=(( tom.engine.adt.tomterm.types.TomTerm )subject);if (tom_is_fun_sym_Tom(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomList  tomMatch39NameNumber_freshVar_0=tom_get_slot_Tom_TomList(tomMatch39NameNumberfreshSubject_1);if ( true ) {


        generateList(deep,tomMatch39NameNumber_freshVar_0, moduleName);
        return;
      }}}if (tom_is_fun_sym_TomInclude(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomList  tomMatch39NameNumber_freshVar_1=tom_get_slot_TomInclude_TomList(tomMatch39NameNumberfreshSubject_1);if ( true ) {


        generateListInclude(deep,tomMatch39NameNumber_freshVar_1, moduleName);
        return;
      }}}if (tom_is_fun_sym_Ref(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch39NameNumber_freshVar_3=tom_get_slot_Ref_TomTerm(tomMatch39NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch39NameNumber_freshVar_2=tomMatch39NameNumber_freshVar_3;{ boolean tomMatch39NameNumber_freshVar_4= false ;if (tom_is_fun_sym_Variable(tomMatch39NameNumber_freshVar_2)) {tomMatch39NameNumber_freshVar_4= true ;} else {if (tom_is_fun_sym_VariableStar(tomMatch39NameNumber_freshVar_2)) {tomMatch39NameNumber_freshVar_4= true ;}}if ((tomMatch39NameNumber_freshVar_4 ==  true )) {if ( true ) {


        buildRef(deep, tomMatch39NameNumber_freshVar_2, moduleName);
        return;
      }}}}}}if (tom_is_fun_sym_Ref(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch39NameNumber_freshVar_5=tom_get_slot_Ref_TomTerm(tomMatch39NameNumberfreshSubject_1);if ( true ) {


        generate(deep, tomMatch39NameNumber_freshVar_5, moduleName);
        return;
      }}}if (tom_is_fun_sym_BuildConstant(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch39NameNumber_freshVar_6=tom_get_slot_BuildConstant_AstName(tomMatch39NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch39NameNumber_freshVar_6)) {{  String  tomMatch39NameNumber_freshVar_7=tom_get_slot_Name_String(tomMatch39NameNumber_freshVar_6);if ( true ) {


        output.write(tomMatch39NameNumber_freshVar_7);
        return;
      }}}}}if (tom_is_fun_sym_BuildTerm(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch39NameNumber_freshVar_8=tom_get_slot_BuildTerm_AstName(tomMatch39NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomList  tomMatch39NameNumber_freshVar_9=tom_get_slot_BuildTerm_Args(tomMatch39NameNumberfreshSubject_1);{  String  tomMatch39NameNumber_freshVar_10=tom_get_slot_BuildTerm_ModuleName(tomMatch39NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch39NameNumber_freshVar_8)) {{  String  tomMatch39NameNumber_freshVar_11=tom_get_slot_Name_String(tomMatch39NameNumber_freshVar_8);if ( true ) {buildTerm(deep,tomMatch39NameNumber_freshVar_11,tomMatch39NameNumber_freshVar_9,tomMatch39NameNumber_freshVar_10)


;
        return;
      }}}}}}}{  tom.engine.adt.tomterm.types.TomTerm  tomMatch39NameNumber_freshVar_12=tomMatch39NameNumberfreshSubject_1;{ boolean tomMatch39NameNumber_freshVar_13= false ;if (tom_is_fun_sym_BuildEmptyList(tomMatch39NameNumber_freshVar_12)) {tomMatch39NameNumber_freshVar_13= true ;} else {if (tom_is_fun_sym_BuildEmptyArray(tomMatch39NameNumber_freshVar_12)) {tomMatch39NameNumber_freshVar_13= true ;} else {if (tom_is_fun_sym_BuildConsList(tomMatch39NameNumber_freshVar_12)) {tomMatch39NameNumber_freshVar_13= true ;} else {if (tom_is_fun_sym_BuildAppendList(tomMatch39NameNumber_freshVar_12)) {tomMatch39NameNumber_freshVar_13= true ;} else {if (tom_is_fun_sym_BuildConsArray(tomMatch39NameNumber_freshVar_12)) {tomMatch39NameNumber_freshVar_13= true ;} else {if (tom_is_fun_sym_BuildAppendArray(tomMatch39NameNumber_freshVar_12)) {tomMatch39NameNumber_freshVar_13= true ;}}}}}}if ((tomMatch39NameNumber_freshVar_13 ==  true )) {if ( true ) {


        buildListOrArray(deep, tomMatch39NameNumber_freshVar_12, moduleName);
        return;
      }}}}if (tom_is_fun_sym_FunctionCall(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch39NameNumber_freshVar_14=tom_get_slot_FunctionCall_AstName(tomMatch39NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomList  tomMatch39NameNumber_freshVar_15=tom_get_slot_FunctionCall_Args(tomMatch39NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch39NameNumber_freshVar_14)) {{  String  tomMatch39NameNumber_freshVar_16=tom_get_slot_Name_String(tomMatch39NameNumber_freshVar_14);if ( true ) {


        buildFunctionCall(deep,tomMatch39NameNumber_freshVar_16, tomMatch39NameNumber_freshVar_15, moduleName);
        return;
      }}}}}}if (tom_is_fun_sym_Composite(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomList  tomMatch39NameNumber_freshVar_17=tom_get_slot_Composite_Args(tomMatch39NameNumberfreshSubject_1);if ( true ) {


        generateList(deep,tomMatch39NameNumber_freshVar_17, moduleName);
        return;
      }}}if (tom_is_fun_sym_Variable(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch39NameNumber_freshVar_18=tom_get_slot_Variable_AstName(tomMatch39NameNumberfreshSubject_1);if (tom_is_fun_sym_PositionName(tomMatch39NameNumber_freshVar_18)) {{  tom.engine.adt.tomname.types.TomNumberList  tomMatch39NameNumber_freshVar_19=tom_get_slot_PositionName_NumberList(tomMatch39NameNumber_freshVar_18);if ( true ) {


          /*
           * sans type: re-definition lorsque %variable est utilise
           * avec type: probleme en cas de filtrage dynamique
           */
        output.write("tom" + TomBase.tomNumberListToString(tomMatch39NameNumber_freshVar_19));
        return;
      }}}}}if (tom_is_fun_sym_Variable(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch39NameNumber_freshVar_20=tom_get_slot_Variable_AstName(tomMatch39NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch39NameNumber_freshVar_20)) {{  String  tomMatch39NameNumber_freshVar_21=tom_get_slot_Name_String(tomMatch39NameNumber_freshVar_20);if ( true ) {


        output.write(tomMatch39NameNumber_freshVar_21);
        return;
      }}}}}if (tom_is_fun_sym_VariableStar(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch39NameNumber_freshVar_22=tom_get_slot_VariableStar_AstName(tomMatch39NameNumberfreshSubject_1);if (tom_is_fun_sym_PositionName(tomMatch39NameNumber_freshVar_22)) {{  tom.engine.adt.tomname.types.TomNumberList  tomMatch39NameNumber_freshVar_23=tom_get_slot_PositionName_NumberList(tomMatch39NameNumber_freshVar_22);if ( true ) {


        output.write("tom" + TomBase.tomNumberListToString(tomMatch39NameNumber_freshVar_23));
        return;
      }}}}}if (tom_is_fun_sym_VariableStar(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch39NameNumber_freshVar_24=tom_get_slot_VariableStar_AstName(tomMatch39NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch39NameNumber_freshVar_24)) {{  String  tomMatch39NameNumber_freshVar_25=tom_get_slot_Name_String(tomMatch39NameNumber_freshVar_24);if ( true ) {


        output.write(tomMatch39NameNumber_freshVar_25);
        return;
      }}}}}if (tom_is_fun_sym_TargetLanguageToTomTerm(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomsignature.types.TargetLanguage  tomMatch39NameNumber_freshVar_26=tom_get_slot_TargetLanguageToTomTerm_Tl(tomMatch39NameNumberfreshSubject_1);if ( true ) {


        generateTargetLanguage(deep,tomMatch39NameNumber_freshVar_26, moduleName);
        return;
      }}}if (tom_is_fun_sym_ExpressionToTomTerm(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch39NameNumber_freshVar_27=tom_get_slot_ExpressionToTomTerm_AstExpression(tomMatch39NameNumberfreshSubject_1);if ( true ) {


        generateExpression(deep,tomMatch39NameNumber_freshVar_27, moduleName);
        return;
      }}}if (tom_is_fun_sym_InstructionToTomTerm(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tominstruction.types.Instruction  tomMatch39NameNumber_freshVar_28=tom_get_slot_InstructionToTomTerm_AstInstruction(tomMatch39NameNumberfreshSubject_1);if ( true ) {


        generateInstruction(deep,tomMatch39NameNumber_freshVar_28, moduleName);
        return;
      }}}if (tom_is_fun_sym_DeclarationToTomTerm(tomMatch39NameNumberfreshSubject_1)) {{  tom.engine.adt.tomdeclaration.types.Declaration  tomMatch39NameNumber_freshVar_29=tom_get_slot_DeclarationToTomTerm_AstDeclaration(tomMatch39NameNumberfreshSubject_1);if ( true ) {


        generateDeclaration(deep,tomMatch39NameNumber_freshVar_29, moduleName);
        return;
      }}}{  tom.engine.adt.tomterm.types.TomTerm  tom_t=tomMatch39NameNumberfreshSubject_1;if ( true ) {


        System.out.println("Cannot generate code for: " + tom_t);
        throw new TomRuntimeException("Cannot generate code for: " + tom_t);
      }}}}

  }

  public void generateExpression(int deep, Expression subject, String moduleName) throws IOException {
    if (tom_is_sort_Expression(subject)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumberfreshSubject_1=(( tom.engine.adt.tomexpression.types.Expression )subject);if (tom_is_fun_sym_Negation(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_0=tom_get_slot_Negation_Arg(tomMatch40NameNumberfreshSubject_1);if ( true ) {

        buildExpNegation(deep, tomMatch40NameNumber_freshVar_0, moduleName);
        return;
      }}}if (tom_is_fun_sym_Conditional(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_1=tom_get_slot_Conditional_Cond(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_2=tom_get_slot_Conditional_Then(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_3=tom_get_slot_Conditional_Else(tomMatch40NameNumberfreshSubject_1);if ( true ) {


        buildExpConditional(deep, tomMatch40NameNumber_freshVar_1, tomMatch40NameNumber_freshVar_2, tomMatch40NameNumber_freshVar_3, moduleName);
        return;
      }}}}}if (tom_is_fun_sym_And(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_4=tom_get_slot_And_Arg1(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_5=tom_get_slot_And_Arg2(tomMatch40NameNumberfreshSubject_1);if ( true ) {


        buildExpAnd(deep, tomMatch40NameNumber_freshVar_4, tomMatch40NameNumber_freshVar_5, moduleName);
        return;
      }}}}if (tom_is_fun_sym_Or(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_6=tom_get_slot_Or_Arg1(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_7=tom_get_slot_Or_Arg2(tomMatch40NameNumberfreshSubject_1);if ( true ) {


        buildExpOr(deep, tomMatch40NameNumber_freshVar_6, tomMatch40NameNumber_freshVar_7, moduleName);
        return;
      }}}}if (tom_is_fun_sym_GreaterThan(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_8=tom_get_slot_GreaterThan_Arg1(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_9=tom_get_slot_GreaterThan_Arg2(tomMatch40NameNumberfreshSubject_1);if ( true ) {


        buildExpGreaterThan(deep, tomMatch40NameNumber_freshVar_8, tomMatch40NameNumber_freshVar_9, moduleName);
        return;
      }}}}if (tom_is_fun_sym_Bottom(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_10=tom_get_slot_Bottom_TomType(tomMatch40NameNumberfreshSubject_1);if ( true ) {


        buildExpBottom(deep,tomMatch40NameNumber_freshVar_10, moduleName);
        return;
      }}}if (tom_is_fun_sym_TrueTL(tomMatch40NameNumberfreshSubject_1)) {if ( true ) {


        buildExpTrue(deep);
        return;
      }}if (tom_is_fun_sym_FalseTL(tomMatch40NameNumberfreshSubject_1)) {if ( true ) {


        buildExpFalse(deep);
        return;
      }}if (tom_is_fun_sym_IsEmptyList(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_11=tom_get_slot_IsEmptyList_Opname(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_12=tom_get_slot_IsEmptyList_Variable(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tom_expList=tomMatch40NameNumber_freshVar_12;if ( true ) {


        buildExpIsEmptyList(deep, tomMatch40NameNumber_freshVar_11, getTermType(tom_expList), tom_expList, moduleName);
        return;
      }}}}}if (tom_is_fun_sym_IsEmptyArray(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_13=tom_get_slot_IsEmptyArray_Opname(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_14=tom_get_slot_IsEmptyArray_Variable(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_15=tom_get_slot_IsEmptyArray_Index(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tom_expArray=tomMatch40NameNumber_freshVar_14;if ( true ) {


        buildExpIsEmptyArray(deep, tomMatch40NameNumber_freshVar_13, getTermType(tom_expArray), tomMatch40NameNumber_freshVar_15, tom_expArray, moduleName);
        return;
      }}}}}}if (tom_is_fun_sym_EqualTerm(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_16=tom_get_slot_EqualTerm_TomType(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_17=tom_get_slot_EqualTerm_Kid1(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_18=tom_get_slot_EqualTerm_Kid2(tomMatch40NameNumberfreshSubject_1);if ( true ) {buildExpEqualTerm(deep,tomMatch40NameNumber_freshVar_16,tomMatch40NameNumber_freshVar_17,tomMatch40NameNumber_freshVar_18,moduleName)


;
        return;
      }}}}}if (tom_is_fun_sym_IsSort(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_20=tom_get_slot_IsSort_AstType(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_21=tom_get_slot_IsSort_Variable(tomMatch40NameNumberfreshSubject_1);if (tom_is_fun_sym_Type(tomMatch40NameNumber_freshVar_20)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_22=tom_get_slot_Type_TomType(tomMatch40NameNumber_freshVar_20);{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_19=tomMatch40NameNumber_freshVar_22;if (tom_is_fun_sym_ASTTomType(tomMatch40NameNumber_freshVar_19)) {if ( true ) {buildExpIsSort(deep,tomMatch40NameNumber_freshVar_19,tomMatch40NameNumber_freshVar_21,moduleName)


;
        return;
      }}}}}}}}if (tom_is_fun_sym_IsFsym(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_23=tom_get_slot_IsFsym_AstName(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_24=tom_get_slot_IsFsym_Variable(tomMatch40NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch40NameNumber_freshVar_23)) {{  String  tomMatch40NameNumber_freshVar_25=tom_get_slot_Name_String(tomMatch40NameNumber_freshVar_23);if ( true ) {


        buildExpIsFsym(deep, tomMatch40NameNumber_freshVar_25, tomMatch40NameNumber_freshVar_24, moduleName);
        return;
      }}}}}}if (tom_is_fun_sym_Cast(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_27=tom_get_slot_Cast_AstType(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_28=tom_get_slot_Cast_Source(tomMatch40NameNumberfreshSubject_1);if (tom_is_fun_sym_Type(tomMatch40NameNumber_freshVar_27)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_29=tom_get_slot_Type_TomType(tomMatch40NameNumber_freshVar_27);{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_30=tom_get_slot_Type_TlType(tomMatch40NameNumber_freshVar_27);{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_26=tomMatch40NameNumber_freshVar_30;if (tom_is_fun_sym_TLType(tomMatch40NameNumber_freshVar_26)) {if ( true ) {


        buildExpCast(deep, tomMatch40NameNumber_freshVar_26, tomMatch40NameNumber_freshVar_28, moduleName);
        return;
      }}}}}}}}}if (tom_is_fun_sym_GetSlot(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_32=tom_get_slot_GetSlot_Codomain(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_33=tom_get_slot_GetSlot_AstName(tomMatch40NameNumberfreshSubject_1);{  String  tomMatch40NameNumber_freshVar_34=tom_get_slot_GetSlot_SlotNameString(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_35=tom_get_slot_GetSlot_Variable(tomMatch40NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch40NameNumber_freshVar_33)) {{  String  tomMatch40NameNumber_freshVar_36=tom_get_slot_Name_String(tomMatch40NameNumber_freshVar_33);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_31=tomMatch40NameNumber_freshVar_35;{ boolean tomMatch40NameNumber_freshVar_37= false ;if (tom_is_fun_sym_Ref(tomMatch40NameNumber_freshVar_31)) {tomMatch40NameNumber_freshVar_37= true ;} else {if (tom_is_fun_sym_Variable(tomMatch40NameNumber_freshVar_31)) {tomMatch40NameNumber_freshVar_37= true ;} else {if (tom_is_fun_sym_BuildTerm(tomMatch40NameNumber_freshVar_31)) {tomMatch40NameNumber_freshVar_37= true ;} else {if (tom_is_fun_sym_ExpressionToTomTerm(tomMatch40NameNumber_freshVar_31)) {tomMatch40NameNumber_freshVar_37= true ;}}}}if ((tomMatch40NameNumber_freshVar_37 ==  true )) {if ( true ) {buildExpGetSlot(deep,tomMatch40NameNumber_freshVar_36,tomMatch40NameNumber_freshVar_34,tomMatch40NameNumber_freshVar_31,moduleName)


;
        return;
      }}}}}}}}}}}if (tom_is_fun_sym_GetSlot(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_39=tom_get_slot_GetSlot_Codomain(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_40=tom_get_slot_GetSlot_AstName(tomMatch40NameNumberfreshSubject_1);{  String  tomMatch40NameNumber_freshVar_41=tom_get_slot_GetSlot_SlotNameString(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_42=tom_get_slot_GetSlot_Variable(tomMatch40NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch40NameNumber_freshVar_40)) {{  String  tomMatch40NameNumber_freshVar_43=tom_get_slot_Name_String(tomMatch40NameNumber_freshVar_40);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_38=tomMatch40NameNumber_freshVar_42;if (tom_is_fun_sym_ExpressionToTomTerm(tomMatch40NameNumber_freshVar_38)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch40NameNumber_freshVar_44=tom_get_slot_ExpressionToTomTerm_AstExpression(tomMatch40NameNumber_freshVar_38);if (tom_is_fun_sym_GetSlot(tomMatch40NameNumber_freshVar_44)) {if ( true ) {buildExpGetSlot(deep,tomMatch40NameNumber_freshVar_43,tomMatch40NameNumber_freshVar_41,tomMatch40NameNumber_freshVar_38,moduleName)

;
        return;
      }}}}}}}}}}}}if (tom_is_fun_sym_GetHead(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_45=tom_get_slot_GetHead_Opname(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_46=tom_get_slot_GetHead_Codomain(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_47=tom_get_slot_GetHead_Variable(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tom_exp=tomMatch40NameNumber_freshVar_47;if ( true ) {buildExpGetHead(deep,tomMatch40NameNumber_freshVar_45,getTermType(tom_exp),tomMatch40NameNumber_freshVar_46,tom_exp,moduleName)


;
        return;
      }}}}}}if (tom_is_fun_sym_GetTail(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_48=tom_get_slot_GetTail_Opname(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_49=tom_get_slot_GetTail_Variable(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tom_exp=tomMatch40NameNumber_freshVar_49;if ( true ) {


        buildExpGetTail(deep, tomMatch40NameNumber_freshVar_48, getTermType(tom_exp), tom_exp, moduleName);
        return;
      }}}}}if (tom_is_fun_sym_AddOne(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_50=tom_get_slot_AddOne_Variable(tomMatch40NameNumberfreshSubject_1);if ( true ) {


        buildAddOne(deep, tomMatch40NameNumber_freshVar_50, moduleName);
        return;
      }}}if (tom_is_fun_sym_GetSize(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_51=tom_get_slot_GetSize_Opname(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_52=tom_get_slot_GetSize_Variable(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tom_exp=tomMatch40NameNumber_freshVar_52;if ( true ) {


        buildExpGetSize(deep,tomMatch40NameNumber_freshVar_51,getTermType(tom_exp), tom_exp, moduleName);
        return;
      }}}}}if (tom_is_fun_sym_GetElement(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_53=tom_get_slot_GetElement_Opname(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomType  tomMatch40NameNumber_freshVar_54=tom_get_slot_GetElement_Codomain(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_55=tom_get_slot_GetElement_Kid1(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_56=tom_get_slot_GetElement_Kid2(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tom_varName=tomMatch40NameNumber_freshVar_55;if ( true ) {


        buildExpGetElement(deep,tomMatch40NameNumber_freshVar_53,getTermType(tom_varName),tomMatch40NameNumber_freshVar_54, tom_varName, tomMatch40NameNumber_freshVar_56, moduleName);
        return;
      }}}}}}}if (tom_is_fun_sym_GetSliceList(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_57=tom_get_slot_GetSliceList_AstName(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_58=tom_get_slot_GetSliceList_VariableBeginAST(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_59=tom_get_slot_GetSliceList_VariableEndAST(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_60=tom_get_slot_GetSliceList_Tail(tomMatch40NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch40NameNumber_freshVar_57)) {{  String  tomMatch40NameNumber_freshVar_61=tom_get_slot_Name_String(tomMatch40NameNumber_freshVar_57);if ( true ) {


        buildExpGetSliceList(deep, tomMatch40NameNumber_freshVar_61, tomMatch40NameNumber_freshVar_58, tomMatch40NameNumber_freshVar_59, tomMatch40NameNumber_freshVar_60,moduleName);
        return;
      }}}}}}}}if (tom_is_fun_sym_GetSliceArray(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch40NameNumber_freshVar_62=tom_get_slot_GetSliceArray_AstName(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_63=tom_get_slot_GetSliceArray_SubjectListName(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_64=tom_get_slot_GetSliceArray_VariableBeginAST(tomMatch40NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_65=tom_get_slot_GetSliceArray_VariableEndAST(tomMatch40NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch40NameNumber_freshVar_62)) {{  String  tomMatch40NameNumber_freshVar_66=tom_get_slot_Name_String(tomMatch40NameNumber_freshVar_62);if ( true ) {


        buildExpGetSliceArray(deep, tomMatch40NameNumber_freshVar_66, tomMatch40NameNumber_freshVar_63, tomMatch40NameNumber_freshVar_64, tomMatch40NameNumber_freshVar_65, moduleName);
        return;
      }}}}}}}}if (tom_is_fun_sym_TomTermToExpression(tomMatch40NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch40NameNumber_freshVar_67=tom_get_slot_TomTermToExpression_AstTerm(tomMatch40NameNumberfreshSubject_1);if ( true ) {


        generate(deep,tomMatch40NameNumber_freshVar_67, moduleName);
        return;
      }}}{  tom.engine.adt.tomexpression.types.Expression  tom_t=tomMatch40NameNumberfreshSubject_1;if ( true ) {

        System.out.println("Cannot generate code for expression: " + tom_t);
        throw new TomRuntimeException("Cannot generate code for expression: " + tom_t);
      }}}}

  }

  public void generateInstruction(int deep, Instruction subject, String moduleName) throws IOException {
    if (tom_is_sort_Instruction(subject)) {{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumberfreshSubject_1=(( tom.engine.adt.tominstruction.types.Instruction )subject);if (tom_is_fun_sym_TargetLanguageToInstruction(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomsignature.types.TargetLanguage  tomMatch41NameNumber_freshVar_0=tom_get_slot_TargetLanguageToInstruction_Tl(tomMatch41NameNumberfreshSubject_1);if ( true ) {generateTargetLanguage(deep,tomMatch41NameNumber_freshVar_0,moduleName)


;
        return;
      }}}if (tom_is_fun_sym_TomTermToInstruction(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_1=tom_get_slot_TomTermToInstruction_Tom(tomMatch41NameNumberfreshSubject_1);if ( true ) {generate(deep,tomMatch41NameNumber_freshVar_1,moduleName)


;
        return;
      }}}if (tom_is_fun_sym_Nop(tomMatch41NameNumberfreshSubject_1)) {if ( true ) {


        return;
      }}if (tom_is_fun_sym_Assign(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_2=tom_get_slot_Assign_Variable(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_3=tom_get_slot_Assign_Source(tomMatch41NameNumberfreshSubject_1);{ boolean tomMatch41NameNumber_freshVar_4= false ;if (tom_is_fun_sym_UnamedVariable(tomMatch41NameNumber_freshVar_2)) {tomMatch41NameNumber_freshVar_4= true ;} else {if (tom_is_fun_sym_UnamedVariableStar(tomMatch41NameNumber_freshVar_2)) {tomMatch41NameNumber_freshVar_4= true ;}}if ((tomMatch41NameNumber_freshVar_4 ==  true )) {if ( true ) {


        return;
      }}}}}}if (tom_is_fun_sym_Assign(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_6=tom_get_slot_Assign_Variable(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_7=tom_get_slot_Assign_Source(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_5=tomMatch41NameNumber_freshVar_6;{ boolean tomMatch41NameNumber_freshVar_9= false ;{  tom.engine.adt.tomoption.types.OptionList  tomMatch41NameNumber_freshVar_8= null ;if (tom_is_fun_sym_Variable(tomMatch41NameNumber_freshVar_5)) {{tomMatch41NameNumber_freshVar_9= true ;tomMatch41NameNumber_freshVar_8=tom_get_slot_Variable_Option(tomMatch41NameNumber_freshVar_5);}} else {if (tom_is_fun_sym_VariableStar(tomMatch41NameNumber_freshVar_5)) {{tomMatch41NameNumber_freshVar_9= true ;tomMatch41NameNumber_freshVar_8=tom_get_slot_VariableStar_Option(tomMatch41NameNumber_freshVar_5);}}}if ((tomMatch41NameNumber_freshVar_9 ==  true )) {if ( true ) {buildAssignVar(deep,tomMatch41NameNumber_freshVar_5,tomMatch41NameNumber_freshVar_8,tomMatch41NameNumber_freshVar_7,moduleName)


;
        return;
      }}}}}}}}if (tom_is_fun_sym_LetAssign(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_11=tom_get_slot_LetAssign_Variable(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_12=tom_get_slot_LetAssign_Source(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_13=tom_get_slot_LetAssign_AstInstruction(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_10=tomMatch41NameNumber_freshVar_11;{ boolean tomMatch41NameNumber_freshVar_15= false ;{  tom.engine.adt.tomoption.types.OptionList  tomMatch41NameNumber_freshVar_14= null ;if (tom_is_fun_sym_Variable(tomMatch41NameNumber_freshVar_10)) {{tomMatch41NameNumber_freshVar_15= true ;tomMatch41NameNumber_freshVar_14=tom_get_slot_Variable_Option(tomMatch41NameNumber_freshVar_10);}} else {if (tom_is_fun_sym_VariableStar(tomMatch41NameNumber_freshVar_10)) {{tomMatch41NameNumber_freshVar_15= true ;tomMatch41NameNumber_freshVar_14=tom_get_slot_VariableStar_Option(tomMatch41NameNumber_freshVar_10);}}}if ((tomMatch41NameNumber_freshVar_15 ==  true )) {if ( true ) {buildLetAssign(deep,tomMatch41NameNumber_freshVar_10,tomMatch41NameNumber_freshVar_14,tomMatch41NameNumber_freshVar_12,tomMatch41NameNumber_freshVar_13,moduleName)


;
        return;
      }}}}}}}}}{ boolean tomMatch41NameNumber_freshVar_20= false ;{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_18= null ;{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_17= null ;{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_16= null ;if (tom_is_fun_sym_Let(tomMatch41NameNumberfreshSubject_1)) {{tomMatch41NameNumber_freshVar_20= true ;tomMatch41NameNumber_freshVar_16=tom_get_slot_Let_Variable(tomMatch41NameNumberfreshSubject_1);tomMatch41NameNumber_freshVar_17=tom_get_slot_Let_Source(tomMatch41NameNumberfreshSubject_1);tomMatch41NameNumber_freshVar_18=tom_get_slot_Let_AstInstruction(tomMatch41NameNumberfreshSubject_1);}} else {if (tom_is_fun_sym_LetRef(tomMatch41NameNumberfreshSubject_1)) {{tomMatch41NameNumber_freshVar_20= true ;tomMatch41NameNumber_freshVar_16=tom_get_slot_LetRef_Variable(tomMatch41NameNumberfreshSubject_1);tomMatch41NameNumber_freshVar_17=tom_get_slot_LetRef_Source(tomMatch41NameNumberfreshSubject_1);tomMatch41NameNumber_freshVar_18=tom_get_slot_LetRef_AstInstruction(tomMatch41NameNumberfreshSubject_1);}} else {if (tom_is_fun_sym_LetAssign(tomMatch41NameNumberfreshSubject_1)) {{tomMatch41NameNumber_freshVar_20= true ;tomMatch41NameNumber_freshVar_16=tom_get_slot_LetAssign_Variable(tomMatch41NameNumberfreshSubject_1);tomMatch41NameNumber_freshVar_17=tom_get_slot_LetAssign_Source(tomMatch41NameNumberfreshSubject_1);tomMatch41NameNumber_freshVar_18=tom_get_slot_LetAssign_AstInstruction(tomMatch41NameNumberfreshSubject_1);}}}}if ((tomMatch41NameNumber_freshVar_20 ==  true )) {{ boolean tomMatch41NameNumber_freshVar_19= false ;if (tom_is_fun_sym_UnamedVariable(tomMatch41NameNumber_freshVar_16)) {tomMatch41NameNumber_freshVar_19= true ;} else {if (tom_is_fun_sym_UnamedVariableStar(tomMatch41NameNumber_freshVar_16)) {tomMatch41NameNumber_freshVar_19= true ;}}if ((tomMatch41NameNumber_freshVar_19 ==  true )) {if ( true ) {generateInstruction(deep,tomMatch41NameNumber_freshVar_18,moduleName)


;
        return;
      }}}}}}}}if (tom_is_fun_sym_Let(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_23=tom_get_slot_Let_Variable(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_24=tom_get_slot_Let_Source(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_25=tom_get_slot_Let_AstInstruction(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_21=tomMatch41NameNumber_freshVar_23;{ boolean tomMatch41NameNumber_freshVar_29= false ;{  tom.engine.adt.tomtype.types.TomType  tomMatch41NameNumber_freshVar_27= null ;{  tom.engine.adt.tomoption.types.OptionList  tomMatch41NameNumber_freshVar_26= null ;if (tom_is_fun_sym_Variable(tomMatch41NameNumber_freshVar_21)) {{tomMatch41NameNumber_freshVar_29= true ;tomMatch41NameNumber_freshVar_26=tom_get_slot_Variable_Option(tomMatch41NameNumber_freshVar_21);tomMatch41NameNumber_freshVar_27=tom_get_slot_Variable_AstType(tomMatch41NameNumber_freshVar_21);}} else {if (tom_is_fun_sym_VariableStar(tomMatch41NameNumber_freshVar_21)) {{tomMatch41NameNumber_freshVar_29= true ;tomMatch41NameNumber_freshVar_26=tom_get_slot_VariableStar_Option(tomMatch41NameNumber_freshVar_21);tomMatch41NameNumber_freshVar_27=tom_get_slot_VariableStar_AstType(tomMatch41NameNumber_freshVar_21);}}}if ((tomMatch41NameNumber_freshVar_29 ==  true )) {if (tom_is_fun_sym_Type(tomMatch41NameNumber_freshVar_27)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch41NameNumber_freshVar_28=tom_get_slot_Type_TlType(tomMatch41NameNumber_freshVar_27);{  tom.engine.adt.tomtype.types.TomType  tomMatch41NameNumber_freshVar_22=tomMatch41NameNumber_freshVar_28;if (tom_is_fun_sym_TLType(tomMatch41NameNumber_freshVar_22)) {if ( true ) {buildLet(deep,tomMatch41NameNumber_freshVar_21,tomMatch41NameNumber_freshVar_26,tomMatch41NameNumber_freshVar_22,tomMatch41NameNumber_freshVar_24,tomMatch41NameNumber_freshVar_25,moduleName)


;
        return;
      }}}}}}}}}}}}}}if (tom_is_fun_sym_LetRef(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_32=tom_get_slot_LetRef_Variable(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_33=tom_get_slot_LetRef_Source(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_34=tom_get_slot_LetRef_AstInstruction(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_30=tomMatch41NameNumber_freshVar_32;{ boolean tomMatch41NameNumber_freshVar_38= false ;{  tom.engine.adt.tomtype.types.TomType  tomMatch41NameNumber_freshVar_36= null ;{  tom.engine.adt.tomoption.types.OptionList  tomMatch41NameNumber_freshVar_35= null ;if (tom_is_fun_sym_Variable(tomMatch41NameNumber_freshVar_30)) {{tomMatch41NameNumber_freshVar_38= true ;tomMatch41NameNumber_freshVar_35=tom_get_slot_Variable_Option(tomMatch41NameNumber_freshVar_30);tomMatch41NameNumber_freshVar_36=tom_get_slot_Variable_AstType(tomMatch41NameNumber_freshVar_30);}} else {if (tom_is_fun_sym_VariableStar(tomMatch41NameNumber_freshVar_30)) {{tomMatch41NameNumber_freshVar_38= true ;tomMatch41NameNumber_freshVar_35=tom_get_slot_VariableStar_Option(tomMatch41NameNumber_freshVar_30);tomMatch41NameNumber_freshVar_36=tom_get_slot_VariableStar_AstType(tomMatch41NameNumber_freshVar_30);}}}if ((tomMatch41NameNumber_freshVar_38 ==  true )) {if (tom_is_fun_sym_Type(tomMatch41NameNumber_freshVar_36)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch41NameNumber_freshVar_37=tom_get_slot_Type_TlType(tomMatch41NameNumber_freshVar_36);{  tom.engine.adt.tomtype.types.TomType  tomMatch41NameNumber_freshVar_31=tomMatch41NameNumber_freshVar_37;if (tom_is_fun_sym_TLType(tomMatch41NameNumber_freshVar_31)) {if ( true ) {buildLetRef(deep,tomMatch41NameNumber_freshVar_30,tomMatch41NameNumber_freshVar_35,tomMatch41NameNumber_freshVar_31,tomMatch41NameNumber_freshVar_33,tomMatch41NameNumber_freshVar_34,moduleName)


;
        return;
      }}}}}}}}}}}}}}if (tom_is_fun_sym_AbstractBlock(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tominstruction.types.InstructionList  tomMatch41NameNumber_freshVar_39=tom_get_slot_AbstractBlock_InstList(tomMatch41NameNumberfreshSubject_1);if ( true ) {


        //`generateInstructionList(deep, instList);
        buildInstructionSequence(deep,tomMatch41NameNumber_freshVar_39,moduleName);
        return;
      }}}if (tom_is_fun_sym_UnamedBlock(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tominstruction.types.InstructionList  tomMatch41NameNumber_freshVar_40=tom_get_slot_UnamedBlock_InstList(tomMatch41NameNumberfreshSubject_1);if ( true ) {buildUnamedBlock(deep,tomMatch41NameNumber_freshVar_40,moduleName)


;
        return;
      }}}if (tom_is_fun_sym_NamedBlock(tomMatch41NameNumberfreshSubject_1)) {{  String  tomMatch41NameNumber_freshVar_41=tom_get_slot_NamedBlock_BlockName(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.InstructionList  tomMatch41NameNumber_freshVar_42=tom_get_slot_NamedBlock_InstList(tomMatch41NameNumberfreshSubject_1);if ( true ) {buildNamedBlock(deep,tomMatch41NameNumber_freshVar_41,tomMatch41NameNumber_freshVar_42,moduleName)


;
        return;
      }}}}if (tom_is_fun_sym_If(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_43=tom_get_slot_If_Condition(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_44=tom_get_slot_If_SuccesInst(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_45=tom_get_slot_If_FailureInst(tomMatch41NameNumberfreshSubject_1);if (tom_is_fun_sym_Nop(tomMatch41NameNumber_freshVar_45)) {if ( true ) {buildIf(deep,tomMatch41NameNumber_freshVar_43,tomMatch41NameNumber_freshVar_44,moduleName)


;
        return;
      }}}}}}if (tom_is_fun_sym_If(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_46=tom_get_slot_If_Condition(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_47=tom_get_slot_If_SuccesInst(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_48=tom_get_slot_If_FailureInst(tomMatch41NameNumberfreshSubject_1);if (tom_is_fun_sym_Nop(tomMatch41NameNumber_freshVar_47)) {if ( true ) {buildIf(deep,tom_make_Negation(tomMatch41NameNumber_freshVar_46),tomMatch41NameNumber_freshVar_48,moduleName)


;
        return;
      }}}}}}if (tom_is_fun_sym_If(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_49=tom_get_slot_If_Condition(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_50=tom_get_slot_If_SuccesInst(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_51=tom_get_slot_If_FailureInst(tomMatch41NameNumberfreshSubject_1);if ( true ) {buildIfWithFailure(deep,tomMatch41NameNumber_freshVar_49,tomMatch41NameNumber_freshVar_50,tomMatch41NameNumber_freshVar_51,moduleName)


;
        return;
      }}}}}if (tom_is_fun_sym_DoWhile(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_52=tom_get_slot_DoWhile_DoInst(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_53=tom_get_slot_DoWhile_Condition(tomMatch41NameNumberfreshSubject_1);if ( true ) {buildDoWhile(deep,tomMatch41NameNumber_freshVar_52,tomMatch41NameNumber_freshVar_53,moduleName)


;
        return;
      }}}}if (tom_is_fun_sym_WhileDo(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomexpression.types.Expression  tomMatch41NameNumber_freshVar_54=tom_get_slot_WhileDo_Condition(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_55=tom_get_slot_WhileDo_DoInst(tomMatch41NameNumberfreshSubject_1);if ( true ) {buildWhileDo(deep,tomMatch41NameNumber_freshVar_54,tomMatch41NameNumber_freshVar_55,moduleName)


;
        return;
      }}}}if (tom_is_fun_sym_TypedAction(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_56=tom_get_slot_TypedAction_AstInstruction(tomMatch41NameNumberfreshSubject_1);if (tom_is_fun_sym_AbstractBlock(tomMatch41NameNumber_freshVar_56)) {{  tom.engine.adt.tominstruction.types.InstructionList  tomMatch41NameNumber_freshVar_57=tom_get_slot_AbstractBlock_InstList(tomMatch41NameNumber_freshVar_56);if ( true ) {generateInstructionList(deep,tomMatch41NameNumber_freshVar_57,moduleName)


;
        return;
      }}}}}if (tom_is_fun_sym_TypedAction(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_58=tom_get_slot_TypedAction_AstInstruction(tomMatch41NameNumberfreshSubject_1);if ( true ) {generateInstruction(deep,tomMatch41NameNumber_freshVar_58,moduleName)


;
        return;
      }}}if (tom_is_fun_sym_Return(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch41NameNumber_freshVar_59=tom_get_slot_Return_Kid1(tomMatch41NameNumberfreshSubject_1);if ( true ) {buildReturn(deep,tomMatch41NameNumber_freshVar_59,moduleName)


;
        return;
      }}}if (tom_is_fun_sym_CompiledMatch(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_60=tom_get_slot_CompiledMatch_AutomataInst(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.OptionList  tomMatch41NameNumber_freshVar_61=tom_get_slot_CompiledMatch_Option(tomMatch41NameNumberfreshSubject_1);if ( true ) {


        //TODO moduleName
        generateInstruction(deep,tomMatch41NameNumber_freshVar_60,moduleName);
        return;
      }}}}if (tom_is_fun_sym_CompiledPattern(tomMatch41NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomList  tomMatch41NameNumber_freshVar_62=tom_get_slot_CompiledPattern_PatternList(tomMatch41NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch41NameNumber_freshVar_63=tom_get_slot_CompiledPattern_AutomataInst(tomMatch41NameNumberfreshSubject_1);if ( true ) {generateInstruction(deep,tomMatch41NameNumber_freshVar_63,moduleName)


;
        return;
      }}}}{  tom.engine.adt.tominstruction.types.Instruction  tom_t=tomMatch41NameNumberfreshSubject_1;if ( true ) {


        System.out.println("Cannot generate code for instruction: " + tom_t);
        throw new TomRuntimeException("Cannot generate code for instruction: " + tom_t);
      }}}}

  }

  public void generateTargetLanguage(int deep, TargetLanguage subject, String moduleName) throws IOException {
    if (tom_is_sort_TargetLanguage(subject)) {{  tom.engine.adt.tomsignature.types.TargetLanguage  tomMatch42NameNumberfreshSubject_1=(( tom.engine.adt.tomsignature.types.TargetLanguage )subject);if (tom_is_fun_sym_TL(tomMatch42NameNumberfreshSubject_1)) {{  String  tomMatch42NameNumber_freshVar_0=tom_get_slot_TL_Code(tomMatch42NameNumberfreshSubject_1);{  tom.engine.adt.tomsignature.types.Position  tomMatch42NameNumber_freshVar_1=tom_get_slot_TL_Start(tomMatch42NameNumberfreshSubject_1);{  tom.engine.adt.tomsignature.types.Position  tomMatch42NameNumber_freshVar_2=tom_get_slot_TL_End(tomMatch42NameNumberfreshSubject_1);if (tom_is_fun_sym_TextPosition(tomMatch42NameNumber_freshVar_1)) {{  int  tomMatch42NameNumber_freshVar_3=tom_get_slot_TextPosition_Line(tomMatch42NameNumber_freshVar_1);{  int  tom_startLine=tomMatch42NameNumber_freshVar_3;if (tom_is_fun_sym_TextPosition(tomMatch42NameNumber_freshVar_2)) {{  int  tomMatch42NameNumber_freshVar_4=tom_get_slot_TextPosition_Line(tomMatch42NameNumber_freshVar_2);if ( true ) {

        output.write(deep, tomMatch42NameNumber_freshVar_0, tom_startLine, tomMatch42NameNumber_freshVar_4- tom_startLine);
        return;
      }}}}}}}}}}if (tom_is_fun_sym_ITL(tomMatch42NameNumberfreshSubject_1)) {{  String  tomMatch42NameNumber_freshVar_5=tom_get_slot_ITL_Code(tomMatch42NameNumberfreshSubject_1);if ( true ) {


        output.write(tomMatch42NameNumber_freshVar_5);
        return;
      }}}if (tom_is_fun_sym_Comment(tomMatch42NameNumberfreshSubject_1)) {{  String  tomMatch42NameNumber_freshVar_6=tom_get_slot_Comment_Code(tomMatch42NameNumberfreshSubject_1);if ( true ) {buildComment(deep,tomMatch42NameNumber_freshVar_6)


;
        return;
      }}}{  tom.engine.adt.tomsignature.types.TargetLanguage  tom_t=tomMatch42NameNumberfreshSubject_1;if ( true ) {


        System.out.println("Cannot generate code for TL: " + tom_t);
        throw new TomRuntimeException("Cannot generate code for TL: " + tom_t);
      }}}}

  }

  public void generateOption(int deep, Option subject, String moduleName) throws IOException {
    if (tom_is_sort_Option(subject)) {{  tom.engine.adt.tomoption.types.Option  tomMatch43NameNumberfreshSubject_1=(( tom.engine.adt.tomoption.types.Option )subject);if (tom_is_fun_sym_DeclarationToOption(tomMatch43NameNumberfreshSubject_1)) {{  tom.engine.adt.tomdeclaration.types.Declaration  tomMatch43NameNumber_freshVar_0=tom_get_slot_DeclarationToOption_AstDeclaration(tomMatch43NameNumberfreshSubject_1);if ( true ) {generateDeclaration(deep,tomMatch43NameNumber_freshVar_0,moduleName)

;
        return;
      }}}if (tom_is_fun_sym_OriginTracking(tomMatch43NameNumberfreshSubject_1)) {if ( true ) {
 return; }}if (tom_is_fun_sym_DefinedSymbol(tomMatch43NameNumberfreshSubject_1)) {if ( true ) {
 return; }}{  tom.engine.adt.tomoption.types.Option  tom_t=tomMatch43NameNumberfreshSubject_1;if ( true ) {


        System.out.println("Cannot generate code for option: " + tom_t);
        throw new TomRuntimeException("Cannot generate code for option: " + tom_t);
      }}}}

  }

  public void generateDeclaration(int deep, Declaration subject, String moduleName) throws IOException {
    if (tom_is_sort_Declaration(subject)) {{  tom.engine.adt.tomdeclaration.types.Declaration  tomMatch44NameNumberfreshSubject_1=(( tom.engine.adt.tomdeclaration.types.Declaration )subject);if (tom_is_fun_sym_EmptyDeclaration(tomMatch44NameNumberfreshSubject_1)) {if ( true ) {

        return;
      }}if (tom_is_fun_sym_AbstractDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomdeclaration.types.DeclarationList  tomMatch44NameNumber_freshVar_0=tom_get_slot_AbstractDecl_DeclList(tomMatch44NameNumberfreshSubject_1);if ( true ) {


        //`generateInstructionList(deep, instList);
        generateDeclarationList(deep,tomMatch44NameNumber_freshVar_0,moduleName);
        return;
      }}}if (tom_is_fun_sym_FunctionDef(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_1=tom_get_slot_FunctionDef_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomList  tomMatch44NameNumber_freshVar_2=tom_get_slot_FunctionDef_ArgumentList(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_3=tom_get_slot_FunctionDef_Codomain(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_4=tom_get_slot_FunctionDef_ThrowsType(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_5=tom_get_slot_FunctionDef_Instruction(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_1)) {{  String  tomMatch44NameNumber_freshVar_6=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_1);if ( true ) {buildFunctionDef(deep,tomMatch44NameNumber_freshVar_6,tomMatch44NameNumber_freshVar_2,tomMatch44NameNumber_freshVar_3,tomMatch44NameNumber_freshVar_4,tomMatch44NameNumber_freshVar_5,moduleName)


;
        return;
      }}}}}}}}}if (tom_is_fun_sym_MethodDef(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_7=tom_get_slot_MethodDef_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomList  tomMatch44NameNumber_freshVar_8=tom_get_slot_MethodDef_ArgumentList(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_9=tom_get_slot_MethodDef_Codomain(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_10=tom_get_slot_MethodDef_ThrowsType(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_11=tom_get_slot_MethodDef_Instruction(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_7)) {{  String  tomMatch44NameNumber_freshVar_12=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_7);if ( true ) {buildMethodDef(deep,tomMatch44NameNumber_freshVar_12,tomMatch44NameNumber_freshVar_8,tomMatch44NameNumber_freshVar_9,tomMatch44NameNumber_freshVar_10,tomMatch44NameNumber_freshVar_11,moduleName)


;
        return;
      }}}}}}}}}if (tom_is_fun_sym_Class(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_13=tom_get_slot_Class_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomForwardType  tomMatch44NameNumber_freshVar_14=tom_get_slot_Class_ExtendsType(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_15=tom_get_slot_Class_SuperTerm(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomdeclaration.types.Declaration  tomMatch44NameNumber_freshVar_16=tom_get_slot_Class_Declaration(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_13)) {{  String  tomMatch44NameNumber_freshVar_17=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_13);if ( true ) {buildClass(deep,tomMatch44NameNumber_freshVar_17,tomMatch44NameNumber_freshVar_14,tomMatch44NameNumber_freshVar_15,tomMatch44NameNumber_freshVar_16,moduleName)


;
        return;
      }}}}}}}}if (tom_is_fun_sym_SymbolDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_18=tom_get_slot_SymbolDecl_AstName(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_18)) {{  String  tomMatch44NameNumber_freshVar_19=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_18);if ( true ) {buildSymbolDecl(deep,tomMatch44NameNumber_freshVar_19,moduleName)


;
        return ;
      }}}}}if (tom_is_fun_sym_ArraySymbolDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_20=tom_get_slot_ArraySymbolDecl_AstName(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_20)) {{  String  tomMatch44NameNumber_freshVar_21=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_20);{  String  tom_tomName=tomMatch44NameNumber_freshVar_21;if ( true ) {


        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_tomName) 
         ||getSymbolTable(moduleName).isUsedSymbolDestructor(tom_tomName)) {
          buildSymbolDecl(deep,tom_tomName,moduleName);
          genDeclArray(tom_tomName,moduleName);
        }
        return ;
      }}}}}}if (tom_is_fun_sym_ListSymbolDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_22=tom_get_slot_ListSymbolDecl_AstName(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_22)) {{  String  tomMatch44NameNumber_freshVar_23=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_22);{  String  tom_tomName=tomMatch44NameNumber_freshVar_23;if ( true ) {


        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_tomName) 
         ||getSymbolTable(moduleName).isUsedSymbolDestructor(tom_tomName)) {
          buildSymbolDecl(deep,tom_tomName,moduleName);
          genDeclList(tom_tomName,moduleName);
        }
        return ;
      }}}}}}if (tom_is_fun_sym_GetImplementationDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_25=tom_get_slot_GetImplementationDecl_Variable(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_26=tom_get_slot_GetImplementationDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_27=tom_get_slot_GetImplementationDecl_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_25)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_28=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_25);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_29=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_25);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_28)) {{  String  tomMatch44NameNumber_freshVar_30=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_28);{  String  tom_name=tomMatch44NameNumber_freshVar_30;if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_29)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_31=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_29);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_32=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_29);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_31)) {{  String  tomMatch44NameNumber_freshVar_33=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_31);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_24=tomMatch44NameNumber_freshVar_32;if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_24)) {if ( true ) {




        if(getSymbolTable(moduleName).isUsedSymbolDestructor(tom_name)) {
          buildGetImplementationDecl(deep,tomMatch44NameNumber_freshVar_33,tom_name,tomMatch44NameNumber_freshVar_24,tomMatch44NameNumber_freshVar_26,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_IsFsymDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_35=tom_get_slot_IsFsymDecl_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_36=tom_get_slot_IsFsymDecl_Variable(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_37=tom_get_slot_IsFsymDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_38=tom_get_slot_IsFsymDecl_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_35)) {{  String  tomMatch44NameNumber_freshVar_39=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_35);{  String  tom_tomName=tomMatch44NameNumber_freshVar_39;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_36)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_40=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_36);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_41=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_36);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_40)) {{  String  tomMatch44NameNumber_freshVar_42=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_40);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_41)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_43=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_41);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_34=tomMatch44NameNumber_freshVar_43;if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_34)) {if ( true ) {



        if(getSymbolTable(moduleName).isUsedSymbolDestructor(tom_tomName)) {
          buildIsFsymDecl(deep,tom_tomName,tomMatch44NameNumber_freshVar_42,tomMatch44NameNumber_freshVar_34,tomMatch44NameNumber_freshVar_37,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_GetSlotDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_45=tom_get_slot_GetSlotDecl_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_46=tom_get_slot_GetSlotDecl_SlotName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_47=tom_get_slot_GetSlotDecl_Variable(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_48=tom_get_slot_GetSlotDecl_Instr(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_45)) {{  String  tomMatch44NameNumber_freshVar_49=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_45);{  String  tom_tomName=tomMatch44NameNumber_freshVar_49;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_47)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_50=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_47);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_51=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_47);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_50)) {{  String  tomMatch44NameNumber_freshVar_52=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_50);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_51)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_53=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_51);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_44=tomMatch44NameNumber_freshVar_53;if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_44)) {if ( true ) {





        if(getSymbolTable(moduleName).isUsedSymbolDestructor(tom_tomName)) {
          buildGetSlotDecl(deep,tom_tomName,tomMatch44NameNumber_freshVar_52,tomMatch44NameNumber_freshVar_44,tomMatch44NameNumber_freshVar_48,tomMatch44NameNumber_freshVar_46,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_EqualTermDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_54=tom_get_slot_EqualTermDecl_TermArg1(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_55=tom_get_slot_EqualTermDecl_TermArg2(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_56=tom_get_slot_EqualTermDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_57=tom_get_slot_EqualTermDecl_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_54)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_58=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_54);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_59=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_54);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_58)) {{  String  tomMatch44NameNumber_freshVar_60=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_58);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_59)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_61=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_59);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_62=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_59);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_61)) {{  String  tomMatch44NameNumber_freshVar_63=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_61);{  String  tom_type1=tomMatch44NameNumber_freshVar_63;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_55)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_64=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_55);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_65=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_55);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_64)) {{  String  tomMatch44NameNumber_freshVar_66=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_64);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_65)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_67=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_65);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_68=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_65);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_67)) {{  String  tomMatch44NameNumber_freshVar_69=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_67);if ( true ) {




        if(getSymbolTable(moduleName).isUsedTypeDefinition(tom_type1)) {
          buildEqualTermDecl(deep,tomMatch44NameNumber_freshVar_60,tomMatch44NameNumber_freshVar_66,tom_type1,tomMatch44NameNumber_freshVar_69,tomMatch44NameNumber_freshVar_56,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_IsSortDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_70=tom_get_slot_IsSortDecl_TermArg(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_71=tom_get_slot_IsSortDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_72=tom_get_slot_IsSortDecl_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_70)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_73=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_70);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_74=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_70);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_73)) {{  String  tomMatch44NameNumber_freshVar_75=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_73);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_74)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_76=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_74);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_77=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_74);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_76)) {{  String  tomMatch44NameNumber_freshVar_78=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_76);{  String  tom_type1=tomMatch44NameNumber_freshVar_78;if ( true ) {


        if(getSymbolTable(moduleName).isUsedTypeDefinition(tom_type1)) {
          buildIsSortDecl(deep,tomMatch44NameNumber_freshVar_75,tom_type1,tomMatch44NameNumber_freshVar_71,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}if (tom_is_fun_sym_GetHeadDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_81=tom_get_slot_GetHeadDecl_Opname(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_82=tom_get_slot_GetHeadDecl_Codomain(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_83=tom_get_slot_GetHeadDecl_Variable(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_84=tom_get_slot_GetHeadDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_79=tomMatch44NameNumber_freshVar_81;if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_82)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_85=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_82);if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_83)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_86=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_83);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_87=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_83);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_86)) {{  String  tomMatch44NameNumber_freshVar_88=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_86);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_87)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_89=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_87);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_90=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_87);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_89)) {{  String  tomMatch44NameNumber_freshVar_91=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_89);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_80=tomMatch44NameNumber_freshVar_90;if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_79)) {{  String  tomMatch44NameNumber_freshVar_92=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_79);{  String  tom_opname=tomMatch44NameNumber_freshVar_92;if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_80)) {if ( true ) {





        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_opname) 
         ||getSymbolTable(moduleName).isUsedSymbolDestructor(tom_opname)) {
          buildGetHeadDecl(deep,tomMatch44NameNumber_freshVar_79,tomMatch44NameNumber_freshVar_88,tomMatch44NameNumber_freshVar_91,tomMatch44NameNumber_freshVar_80,tomMatch44NameNumber_freshVar_85,tomMatch44NameNumber_freshVar_84,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_GetTailDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_95=tom_get_slot_GetTailDecl_Opname(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_96=tom_get_slot_GetTailDecl_Variable(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_97=tom_get_slot_GetTailDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_93=tomMatch44NameNumber_freshVar_95;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_96)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_98=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_96);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_99=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_96);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_98)) {{  String  tomMatch44NameNumber_freshVar_100=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_98);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_99)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_101=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_99);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_102=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_99);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_101)) {{  String  tomMatch44NameNumber_freshVar_103=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_101);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_94=tomMatch44NameNumber_freshVar_102;if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_93)) {{  String  tomMatch44NameNumber_freshVar_104=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_93);{  String  tom_opname=tomMatch44NameNumber_freshVar_104;if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_94)) {if ( true ) {




        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_opname) 
         ||getSymbolTable(moduleName).isUsedSymbolDestructor(tom_opname)) {
          buildGetTailDecl(deep,tomMatch44NameNumber_freshVar_93,tomMatch44NameNumber_freshVar_100,tomMatch44NameNumber_freshVar_103,tomMatch44NameNumber_freshVar_94,tomMatch44NameNumber_freshVar_97,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_IsEmptyDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_107=tom_get_slot_IsEmptyDecl_Opname(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_108=tom_get_slot_IsEmptyDecl_Variable(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_109=tom_get_slot_IsEmptyDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_105=tomMatch44NameNumber_freshVar_107;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_108)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_110=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_108);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_111=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_108);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_110)) {{  String  tomMatch44NameNumber_freshVar_112=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_110);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_111)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_113=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_111);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_114=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_111);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_113)) {{  String  tomMatch44NameNumber_freshVar_115=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_113);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_106=tomMatch44NameNumber_freshVar_114;if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_105)) {{  String  tomMatch44NameNumber_freshVar_116=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_105);{  String  tom_opname=tomMatch44NameNumber_freshVar_116;if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_106)) {if ( true ) {




        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_opname) 
         ||getSymbolTable(moduleName).isUsedSymbolDestructor(tom_opname)) {
          buildIsEmptyDecl(deep,tomMatch44NameNumber_freshVar_105,tomMatch44NameNumber_freshVar_112,tomMatch44NameNumber_freshVar_115,tomMatch44NameNumber_freshVar_106,tomMatch44NameNumber_freshVar_109,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_MakeEmptyList(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_117=tom_get_slot_MakeEmptyList_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_118=tom_get_slot_MakeEmptyList_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_119=tom_get_slot_MakeEmptyList_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_117)) {{  String  tomMatch44NameNumber_freshVar_120=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_117);{  String  tom_opname=tomMatch44NameNumber_freshVar_120;if ( true ) {


        TomType returnType = TomBase.getSymbolCodomain(getSymbolFromName(tom_opname));
        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_opname) 
        || getSymbolTable(moduleName).isUsedSymbolDestructor(tom_opname)) {
          genDeclMake("tom_empty_list_" + tom_opname,returnType,tom_empty_list_concTomTerm(),tomMatch44NameNumber_freshVar_118,moduleName);
        }
        return;
      }}}}}}}}if (tom_is_fun_sym_MakeAddList(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_124=tom_get_slot_MakeAddList_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_125=tom_get_slot_MakeAddList_VarElt(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_126=tom_get_slot_MakeAddList_VarList(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_127=tom_get_slot_MakeAddList_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_128=tom_get_slot_MakeAddList_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_124)) {{  String  tomMatch44NameNumber_freshVar_129=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_124);{  String  tom_opname=tomMatch44NameNumber_freshVar_129;{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_121=tomMatch44NameNumber_freshVar_125;{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_122=tomMatch44NameNumber_freshVar_126;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_121)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_130=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_121);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_130)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_131=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_130);if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_131)) {if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_122)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_132=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_122);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_123=tomMatch44NameNumber_freshVar_132;if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_123)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_133=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_123);if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_133)) {if ( true ) {





        TomType returnType = tomMatch44NameNumber_freshVar_123;
        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_opname) 
         ||getSymbolTable(moduleName).isUsedSymbolDestructor(tom_opname)) {
          genDeclMake("tom_cons_list_" + tom_opname,returnType,tom_cons_list_concTomTerm(tomMatch44NameNumber_freshVar_121,tom_cons_list_concTomTerm(tomMatch44NameNumber_freshVar_122,tom_empty_list_concTomTerm())),tomMatch44NameNumber_freshVar_127,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_GetElementDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_136=tom_get_slot_GetElementDecl_Opname(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_137=tom_get_slot_GetElementDecl_Variable(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_138=tom_get_slot_GetElementDecl_Index(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_139=tom_get_slot_GetElementDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_134=tomMatch44NameNumber_freshVar_136;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_137)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_140=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_137);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_141=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_137);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_140)) {{  String  tomMatch44NameNumber_freshVar_142=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_140);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_141)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_143=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_141);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_144=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_141);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_143)) {{  String  tomMatch44NameNumber_freshVar_145=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_143);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_135=tomMatch44NameNumber_freshVar_144;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_138)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_146=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_138);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_146)) {{  String  tomMatch44NameNumber_freshVar_147=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_146);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_134)) {{  String  tomMatch44NameNumber_freshVar_148=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_134);if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_135)) {if ( true ) {





        if(getSymbolTable(moduleName).isUsedSymbolDestructor(tomMatch44NameNumber_freshVar_148)) {
          buildGetElementDecl(deep,tomMatch44NameNumber_freshVar_134,tomMatch44NameNumber_freshVar_142,tomMatch44NameNumber_freshVar_147,tomMatch44NameNumber_freshVar_145,tomMatch44NameNumber_freshVar_135,tomMatch44NameNumber_freshVar_139,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_GetSizeDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_151=tom_get_slot_GetSizeDecl_Opname(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_152=tom_get_slot_GetSizeDecl_Variable(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_153=tom_get_slot_GetSizeDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_149=tomMatch44NameNumber_freshVar_151;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_152)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_154=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_152);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_155=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_152);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_154)) {{  String  tomMatch44NameNumber_freshVar_156=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_154);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_155)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_157=tom_get_slot_Type_TomType(tomMatch44NameNumber_freshVar_155);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_158=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_155);if (tom_is_fun_sym_ASTTomType(tomMatch44NameNumber_freshVar_157)) {{  String  tomMatch44NameNumber_freshVar_159=tom_get_slot_ASTTomType_String(tomMatch44NameNumber_freshVar_157);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_150=tomMatch44NameNumber_freshVar_158;if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_149)) {{  String  tomMatch44NameNumber_freshVar_160=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_149);if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_150)) {if ( true ) {





	  if(getSymbolTable(moduleName).isUsedSymbolDestructor(tomMatch44NameNumber_freshVar_160)) {
	    buildGetSizeDecl(deep,tomMatch44NameNumber_freshVar_149,tomMatch44NameNumber_freshVar_156,tomMatch44NameNumber_freshVar_159,tomMatch44NameNumber_freshVar_150,tomMatch44NameNumber_freshVar_153,moduleName);
	  }
	  return;
	}}}}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_MakeEmptyArray(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_161=tom_get_slot_MakeEmptyArray_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_162=tom_get_slot_MakeEmptyArray_VarSize(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_163=tom_get_slot_MakeEmptyArray_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_164=tom_get_slot_MakeEmptyArray_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_161)) {{  String  tomMatch44NameNumber_freshVar_165=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_161);{  String  tom_opname=tomMatch44NameNumber_freshVar_165;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_162)) {{  tom.engine.adt.tomoption.types.OptionList  tomMatch44NameNumber_freshVar_166=tom_get_slot_Variable_Option(tomMatch44NameNumber_freshVar_162);{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_167=tom_get_slot_Variable_AstName(tomMatch44NameNumber_freshVar_162);{  tom.engine.adt.tomconstraint.types.ConstraintList  tomMatch44NameNumber_freshVar_168=tom_get_slot_Variable_Constraints(tomMatch44NameNumber_freshVar_162);if ( true ) {




	TomType returnType = TomBase.getSymbolCodomain(getSymbolFromName(tom_opname));
        TomTerm newVar = tom_make_Variable(tomMatch44NameNumber_freshVar_166,tomMatch44NameNumber_freshVar_167,getSymbolTable(moduleName).getIntType(),tomMatch44NameNumber_freshVar_168);
        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_opname)) {
          genDeclMake("tom_empty_array_" + tom_opname,returnType,tom_cons_list_concTomTerm(newVar,tom_empty_list_concTomTerm()),tomMatch44NameNumber_freshVar_163,moduleName);
        }
        return;
      }}}}}}}}}}}}}if (tom_is_fun_sym_MakeAddArray(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_172=tom_get_slot_MakeAddArray_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_173=tom_get_slot_MakeAddArray_VarElt(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_174=tom_get_slot_MakeAddArray_VarList(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_175=tom_get_slot_MakeAddArray_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_176=tom_get_slot_MakeAddArray_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_172)) {{  String  tomMatch44NameNumber_freshVar_177=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_172);{  String  tom_opname=tomMatch44NameNumber_freshVar_177;{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_169=tomMatch44NameNumber_freshVar_173;{  tom.engine.adt.tomterm.types.TomTerm  tomMatch44NameNumber_freshVar_170=tomMatch44NameNumber_freshVar_174;if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_169)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_178=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_169);if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_178)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_179=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_178);if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_179)) {if (tom_is_fun_sym_Variable(tomMatch44NameNumber_freshVar_170)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_180=tom_get_slot_Variable_AstType(tomMatch44NameNumber_freshVar_170);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_171=tomMatch44NameNumber_freshVar_180;if (tom_is_fun_sym_Type(tomMatch44NameNumber_freshVar_171)) {{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_181=tom_get_slot_Type_TlType(tomMatch44NameNumber_freshVar_171);if (tom_is_fun_sym_TLType(tomMatch44NameNumber_freshVar_181)) {if ( true ) {





        TomType returnType = tomMatch44NameNumber_freshVar_171;
        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_opname)) {
          genDeclMake("tom_cons_array_" + tom_opname,returnType,tom_cons_list_concTomTerm(tomMatch44NameNumber_freshVar_169,tom_cons_list_concTomTerm(tomMatch44NameNumber_freshVar_170,tom_empty_list_concTomTerm())),tomMatch44NameNumber_freshVar_175,moduleName);
        }
        return;
      }}}}}}}}}}}}}}}}}}}}}}}if (tom_is_fun_sym_MakeDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomname.types.TomName  tomMatch44NameNumber_freshVar_182=tom_get_slot_MakeDecl_AstName(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomtype.types.TomType  tomMatch44NameNumber_freshVar_183=tom_get_slot_MakeDecl_AstType(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomterm.types.TomList  tomMatch44NameNumber_freshVar_184=tom_get_slot_MakeDecl_Args(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tominstruction.types.Instruction  tomMatch44NameNumber_freshVar_185=tom_get_slot_MakeDecl_Instr(tomMatch44NameNumberfreshSubject_1);{  tom.engine.adt.tomoption.types.Option  tomMatch44NameNumber_freshVar_186=tom_get_slot_MakeDecl_OrgTrack(tomMatch44NameNumberfreshSubject_1);if (tom_is_fun_sym_Name(tomMatch44NameNumber_freshVar_182)) {{  String  tomMatch44NameNumber_freshVar_187=tom_get_slot_Name_String(tomMatch44NameNumber_freshVar_182);{  String  tom_opname=tomMatch44NameNumber_freshVar_187;if ( true ) {


        if(getSymbolTable(moduleName).isUsedSymbolConstructor(tom_opname)) {
          genDeclMake("tom_make_" + tom_opname,tomMatch44NameNumber_freshVar_183,tomMatch44NameNumber_freshVar_184,tomMatch44NameNumber_freshVar_185,moduleName);
        }
        return;
      }}}}}}}}}}if (tom_is_fun_sym_TypeTermDecl(tomMatch44NameNumberfreshSubject_1)) {{  tom.engine.adt.tomdeclaration.types.DeclarationList  tomMatch44NameNumber_freshVar_188=tom_get_slot_TypeTermDecl_Declarations(tomMatch44NameNumberfreshSubject_1);if ( true ) {


        generateDeclarationList(deep, tomMatch44NameNumber_freshVar_188, moduleName);
        return;
      }}}{  tom.engine.adt.tomdeclaration.types.Declaration  tom_t=tomMatch44NameNumberfreshSubject_1;if ( true ) {


        System.out.println("Cannot generate code for declaration: " + tom_t);
        throw new TomRuntimeException("Cannot generate code for declaration: " + tom_t);
      }}}}

  }

  public void generateListInclude(int deep, TomList subject, String moduleName) throws IOException {
    output.setSingleLine();
    generateList(deep, subject, moduleName);
    output.unsetSingleLine();
  }

  public void generateList(int deep, TomList subject, String moduleName)
    throws IOException {
    while(!subject.isEmptyconcTomTerm()) {
      generate(deep, subject.getHeadconcTomTerm(), moduleName);
      subject = subject.getTailconcTomTerm();
    }
  }

  public void generateOptionList(int deep, OptionList subject, String moduleName)
    throws IOException {
    while(!subject.isEmptyconcOption()) {
      generateOption(deep,subject.getHeadconcOption(), moduleName);
      subject = subject.getTailconcOption();
    }
  }

  public void generateInstructionList(int deep, InstructionList subject, String moduleName)
    throws IOException {
    while(!subject.isEmptyconcInstruction()) {
      generateInstruction(deep,subject.getHeadconcInstruction(), moduleName);
      subject = subject.getTailconcInstruction();
    }
    if(prettyMode) {
      output.writeln();
    }
  }

  public void generateDeclarationList(int deep, DeclarationList subject, String moduleName)
    throws IOException {
    while(!subject.isEmptyconcDeclaration()) {
      generateDeclaration(deep,subject.getHeadconcDeclaration(), moduleName);
      subject = subject.getTailconcDeclaration();
    }
  }

  public void generatePairNameDeclList(int deep, PairNameDeclList pairNameDeclList, String moduleName)
    throws IOException {
    while ( !pairNameDeclList.isEmptyconcPairNameDecl() ) {
      generateDeclaration(deep, pairNameDeclList.getHeadconcPairNameDecl().getSlotDecl(), moduleName);
      pairNameDeclList = pairNameDeclList.getTailconcPairNameDecl();
    }
  }

    // ------------------------------------------------------------

  protected abstract void genDecl(String returnType,
                                  String declName,
                                  String suffix,
                                  String args[],
                                  TargetLanguage tlCode,
                                  String moduleName) throws IOException;

  protected abstract void genDeclInstr(String returnType,
                                       String declName,
                                       String suffix,
                                       String args[],
                                       Instruction instr,
                                       int deep,
                                       String moduleName) throws IOException;

  protected abstract void genDeclMake(String funName, TomType returnType,
                                      TomList argList, Instruction instr, String moduleName) throws IOException;

  protected abstract void genDeclList(String name, String moduleName) throws IOException;

  protected abstract void genDeclArray(String name, String moduleName) throws IOException;

  // ------------------------------------------------------------

  protected abstract void buildInstructionSequence(int deep, InstructionList instructionList, String moduleName) throws IOException;
  protected abstract void buildComment(int deep, String text) throws IOException;
  protected abstract void buildTerm(int deep, String name, TomList argList, String moduleName) throws IOException;
  protected abstract void buildRef(int deep, TomTerm term, String moduleName) throws IOException;
  protected abstract void buildListOrArray(int deep, TomTerm list, String moduleName) throws IOException;

  protected abstract void buildFunctionCall(int deep, String name, TomList argList, String moduleName)  throws IOException;
  protected abstract void buildFunctionDef(int deep, String tomName, TomList argList, TomType codomain, TomType throwsType, Instruction instruction, String moduleName) throws IOException;
  protected void buildMethodDef(int deep, String tomName, TomList argList, TomType codomain, TomType throwsType, Instruction instruction, String moduleName) throws IOException {
    throw new TomRuntimeException("Backend "+getClass()+" does not support Methods");
  }

  /*buildClass is not abstract since only Java backend supports class
    only backends that supports Class should overload buildClass
   */
  protected void buildClass(int deep, String tomName, TomForwardType extendsFwdType, TomTerm superTerm, Declaration declaration, String moduleName) throws IOException {
    throw new TomRuntimeException("Backend does not support Class");
  }

  protected abstract void buildExpNegation(int deep, Expression exp, String moduleName) throws IOException;

  protected abstract void buildExpConditional(int deep, Expression cond,Expression exp1, Expression exp2, String moduleName) throws IOException;
  protected abstract void buildExpAnd(int deep, Expression exp1, Expression exp2, String moduleName) throws IOException;
  protected abstract void buildExpOr(int deep, Expression exp1, Expression exp2, String moduleName) throws IOException;
  protected abstract void buildExpGreaterThan(int deep, Expression exp1, Expression exp2, String moduleName) throws IOException;
  protected abstract void buildExpBottom(int deep, TomType type, String moduleName) throws IOException;
  protected abstract void buildExpTrue(int deep) throws IOException;
  protected abstract void buildExpFalse(int deep) throws IOException;
  protected abstract void buildExpIsEmptyList(int deep, TomName opName, TomType type, TomTerm expList, String moduleName) throws IOException;
  protected abstract void buildExpIsEmptyArray(int deep, TomName opName, TomType type, TomTerm expIndex, TomTerm expArray, String moduleName) throws IOException;
  protected abstract void buildExpEqualTerm(int deep, TomType type, TomTerm exp1,TomTerm exp2, String moduleName) throws IOException;
  protected abstract void buildExpIsSort(int deep, TomType type, TomTerm exp, String moduleName) throws IOException;
  protected abstract void buildExpIsFsym(int deep, String opname, TomTerm var, String moduleName) throws IOException;
  protected abstract void buildExpCast(int deep, TomType type, Expression exp, String moduleName) throws IOException;
  protected abstract void buildExpGetSlot(int deep, String opname, String slotName, TomTerm exp, String moduleName) throws IOException;
  protected abstract void buildExpGetHead(int deep, TomName opName, TomType domain, TomType codomain, TomTerm var, String moduleName) throws IOException;
  protected abstract void buildExpGetTail(int deep, TomName opName, TomType type1, TomTerm var, String moduleName) throws IOException;
  protected abstract void buildExpGetSize(int deep, TomName opNameAST, TomType type1, TomTerm var, String moduleName) throws IOException;
  protected abstract void buildExpGetElement(int deep, TomName opNameAST, TomType domain, TomType codomain, TomTerm varName, TomTerm varIndex, String moduleName) throws IOException;
  protected abstract void buildExpGetSliceList(int deep, String name, TomTerm varBegin, TomTerm varEnd, TomTerm tailSlice, String moduleName) throws IOException;
  protected abstract void buildExpGetSliceArray(int deep, String name, TomTerm varArray, TomTerm varBegin, TomTerm expEnd, String moduleName) throws IOException;
  protected abstract void buildAssignVar(int deep, TomTerm var, OptionList list, Expression exp, String moduleName) throws IOException ;
  protected abstract void buildLetAssign(int deep, TomTerm var, OptionList list, Expression exp, Instruction body, String moduleName) throws IOException ;
  protected abstract void buildLet(int deep, TomTerm var, OptionList list, TomType tlType, Expression exp, Instruction body, String moduleName) throws IOException ;
  protected abstract void buildLetRef(int deep, TomTerm var, OptionList list, TomType tlType, Expression exp, Instruction body, String moduleName) throws IOException ;
  protected abstract void buildNamedBlock(int deep, String blockName, InstructionList instList, String modulename) throws IOException ;
  protected abstract void buildUnamedBlock(int deep, InstructionList instList, String moduleName) throws IOException ;
  protected abstract void buildIf(int deep, Expression exp, Instruction succes, String moduleName) throws IOException ;
  protected abstract void buildIfWithFailure(int deep, Expression exp, Instruction succes, Instruction failure, String moduleName) throws IOException ;
  protected abstract void buildDoWhile(int deep, Instruction succes, Expression exp, String moduleName) throws IOException;
  protected abstract void buildWhileDo(int deep, Expression exp, Instruction succes, String moduleName) throws IOException;
  protected abstract void buildAddOne(int deep, TomTerm var, String moduleName) throws IOException;
  protected abstract void buildReturn(int deep, TomTerm exp, String moduleName) throws IOException ;
  protected abstract void buildSymbolDecl(int deep, String tomName, String moduleName) throws IOException ;
  protected abstract void buildGetImplementationDecl(int deep, String type, String name,
                                              TomType tlType, Instruction instr, String moduleName) throws IOException;

  protected abstract void buildIsFsymDecl(int deep, String tomName, String name1,
                                          TomType tlType, Instruction instr, String moduleName) throws IOException;
  protected abstract void buildGetSlotDecl(int deep, String tomName, String name1,
                                           TomType tlType, Instruction instr, TomName slotName, String moduleName) throws IOException;
  protected abstract void buildEqualTermDecl(int deep, String name1, String name2,
                                              String type1, String type2, Instruction instr, String moduleName) throws IOException;
  protected abstract void buildIsSortDecl(int deep, String name1, 
                                              String type1, Instruction instr, String moduleName) throws IOException;
  protected abstract void buildGetHeadDecl(int deep, TomName opNameAST, String varName, String suffix, TomType domain, TomType codomain, Instruction instr, String moduleName) throws IOException;
  protected abstract void buildGetTailDecl(int deep, TomName opNameAST, String varName, String type, TomType tlType, Instruction instr, String moduleName) throws IOException;
  protected abstract void buildIsEmptyDecl(int deep, TomName opNameAST, String varName, String type,
                                           TomType tlType, Instruction instr, String moduleName) throws IOException;
  protected abstract void buildGetElementDecl(int deep, TomName opNameAST, String name1, String name2,
                                              String type1, TomType tlType1, Instruction instr, String moduleName) throws IOException;
  protected abstract void buildGetSizeDecl(int deep, TomName opNameAST, String name1, String type,
                                           TomType tlType, Instruction instr, String moduleName) throws IOException;

} // class TomAbstractGenerator
